//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "AdministraceSkupinyPokojuFile.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TAdministraceSkupinyPokoju *AdministraceSkupinyPokoju;
//---------------------------------------------------------------------------
__fastcall TAdministraceSkupinyPokoju::TAdministraceSkupinyPokoju(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSkupinyPokoju::OKButtonClick(TObject *Sender)
{
    SeznamSkupinPokoju->UlozDoDatabaze();
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSkupinyPokoju::StornoButtonClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSkupinyPokoju::FormShow(TObject *Sender)
{
    SeznamSkupinPokoju = new TSeznamSkupinPokoju();
    SeznamVsechPokoju = new TSeznamPokoju();
    AktualizujZobrazeniNaFormulari();
}
//---------------------------------------------------------------------------

void TAdministraceSkupinyPokoju::AktualizujZobrazeniNaFormulari(void)
{
    NovaSkupinaEdit->Text = "";
    SeznamSkupinPokoju->GetSeznamTStringList(SkupinyPokojuListBox->Items);
    SeznamVsechPokoju->GetSeznamTStringList(VsechnyPokojeListBox->Items);
    AktualizujZobrazeniNaFormulariJenPokojeVeSkupine();
}
//---------------------------------------------------------------------------

void TAdministraceSkupinyPokoju::AktualizujZobrazeniNaFormulariJenPokojeVeSkupine(void)
{
    PokojeVeSkupineListBox->Clear();
    if(SkupinyPokojuListBox->ItemIndex >= 0) // je vybran skupina
    {
        SeznamSkupinPokoju->GetSeznamTStringListPokojuVeSkupine(
            SkupinyPokojuListBox->Items->Strings[SkupinyPokojuListBox->ItemIndex],
            PokojeVeSkupineListBox->Items);
    }
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSkupinyPokoju::FormHide(TObject *Sender)
{
    delete SeznamSkupinPokoju;
    delete SeznamVsechPokoju;
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSkupinyPokoju::SkupinyPokojuListBoxClick(
      TObject *Sender)
{
    AktualizujZobrazeniNaFormulariJenPokojeVeSkupine();
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSkupinyPokoju::OdstranSkupinuButtonClick(
      TObject *Sender)
{
    if(SkupinyPokojuListBox->ItemIndex >= 0) // je vybran skupina
    {
        SeznamSkupinPokoju->OdstranSkupinuPokoju(
            SkupinyPokojuListBox->Items->Strings[SkupinyPokojuListBox->ItemIndex]);
    }
    AktualizujZobrazeniNaFormulari();
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSkupinyPokoju::PridejSkupinuButtonClick(
      TObject *Sender)
{
    if(NovaSkupinaEdit->Text != "") // je nco vyplnno
    {
        SeznamSkupinPokoju->PridejSkupinuPokoju(NovaSkupinaEdit->Text);
        AktualizujZobrazeniNaFormulari();
    }
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSkupinyPokoju::NovaSkupinaEditKeyDown(
      TObject *Sender, WORD &Key, TShiftState Shift)
{
    if(Key == VK_RETURN)
        PridejSkupinuButtonClick(Sender);

}
//---------------------------------------------------------------------------

vector< TPokoj > TAdministraceSkupinyPokoju::VytvorVectorZVybranychPokoju(
                                               TListBox * _ListBox) const
    // vyuv ji OdeberPokojeButtonClick() a PridejPokojeButtonClick()
    // pro pedn vybranch pokoj
    // TListBox * by ml bt const, ale kvli SelCount a Selected nen
    // Borlandi je neudlali const.
{
    vector< TPokoj > VybranePokoje;
    VybranePokoje.clear();

    if(_ListBox->SelCount > 0)
    {
        for(int i = 0; i < _ListBox->Items->Count; i++)
        {
            if(_ListBox->Selected[i])
            {
                VybranePokoje.push_back(
                        SeznamVsechPokoju->GetPokoj(
                                            _ListBox->Items->Strings[i]));
            }
        }
    }
    return VybranePokoje;
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSkupinyPokoju::OdeberPokojeButtonClick(
      TObject *Sender)
{
    if(SkupinyPokojuListBox->ItemIndex >=0) // je vybran skupina
    {
        SeznamSkupinPokoju->OdstranPokojeZeSkupiny(
            SkupinyPokojuListBox->Items->Strings[SkupinyPokojuListBox->ItemIndex],
            VytvorVectorZVybranychPokoju(PokojeVeSkupineListBox));
        AktualizujZobrazeniNaFormulariJenPokojeVeSkupine();
    }
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSkupinyPokoju::PridejPokojeButtonClick(
      TObject *Sender)
{
    if(SkupinyPokojuListBox->ItemIndex >=0) // je vybran skupina
    {
        SeznamSkupinPokoju->PridejPokojeDoSkupiny(
            SkupinyPokojuListBox->Items->Strings[SkupinyPokojuListBox->ItemIndex],
            VytvorVectorZVybranychPokoju(VsechnyPokojeListBox));
        AktualizujZobrazeniNaFormulariJenPokojeVeSkupine();
    }
}
//---------------------------------------------------------------------------

