//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "AdministraceTypyPokojuFile.h"
#include "DefinovaniCenFile.h"
#include "TSeznamTypuPokoju.h"
#include <vector>
//---------------------------------------------------------------------------
using std::vector;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TAdministraceTypyPokoju *AdministraceTypyPokoju;
//---------------------------------------------------------------------------

__fastcall TAdministraceTypyPokoju::TAdministraceTypyPokoju(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceTypyPokoju::OKButtonClick(TObject *Sender)
{
    SeznamTypuPokoju->UlozDoDatabaze();
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceTypyPokoju::NadefinujCenyButtonClick(TObject *Sender)
    // zobraz formul "TDefinovaniCen" a ped mu vektor obsahujc ID typ
    // pokoj, kter uivatel vybral
{
    if(TypyPokojuListBox->SelCount > 0)
        DefinovaniCen->MyShowModal(VytvorVectorZVybranychTypuPokoju());
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceTypyPokoju::FormShow(TObject *Sender)
{
    SeznamTypuPokoju = new TSeznamTypuPokoju();

    AktualizujZobrazeniNaFormulari();
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceTypyPokoju::PridejButtonClick(TObject *Sender)
{
    if((NovyTypEdit->Text != "")
            && (PocetLuzekEdit->Text != ""))
    {
        try
        {
            PocetLuzekEdit->Text.ToInt();
        }
        catch(EConvertError *)
        {
            Application->MessageBox("Poet pokoj nen platn slo.", "Chyba", MB_OK);
            return;
        }

        SeznamTypuPokoju->PridejTypPokoje(NovyTypEdit->Text, PocetLuzekEdit->Text.ToInt());
        AktualizujZobrazeniNaFormulari();
    }
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceTypyPokoju::OdstranVybraneButtonClick(
            TObject *Sender)
    // Pokud lze (tabulka pokoje_tab a ceny_tab neobsahuje ID tohoto typu)
    // odstran vybran typy pokoj.
{
    if(TypyPokojuListBox->SelCount > 0)
    {
        for(int i = 0; i < TypyPokojuListBox->Items->Count; i++)
        {
            if(TypyPokojuListBox->Selected[i])
            {
                if(!SeznamTypuPokoju->OdstranTypPokoje(
                                        TypyPokojuListBox->Items->Strings[i]))
                {
                    Application->MessageBox(TMyString(
                        TMyString("K typu pokoje \"") +
                        TypyPokojuListBox->Items->Strings[i] +
                        "\" jsou jet njak pokoje piazeny!").c_str(),
                                                            "Chyba", MB_OK);
                    break;
                }
            }
        }
        AktualizujZobrazeniNaFormulari();
    }
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceTypyPokoju::StornoButtonClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceTypyPokoju::FormHide(TObject *Sender)
{
    delete SeznamTypuPokoju;
}
//---------------------------------------------------------------------------

void TAdministraceTypyPokoju::AktualizujZobrazeniNaFormulari(void)
{
    SeznamTypuPokoju->GetSeznamTStringList(TypyPokojuListBox->Items);
}
//--------------------------------------------------------------------------

vector< int > TAdministraceTypyPokoju::VytvorVectorZVybranychTypuPokoju(void)
    // vyuv ji NadefinujCenyButtonClick() pro pedn ID vybranch typ
    // pokoj formuli TDefinovaniCen
{
    vector<int> VybranePokoje;
    VybranePokoje.clear();

    if(TypyPokojuListBox->SelCount > 0)
    {
        for(int i = 0; i < TypyPokojuListBox->Items->Count; i++)
        {
            if(TypyPokojuListBox->Selected[i])
            {
                VybranePokoje.push_back(SeznamTypuPokoju->GetTypPokojeID(
                                        TypyPokojuListBox->Items->Strings[i]));
            }
        }
    }
    return VybranePokoje;
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceTypyPokoju::NovyTypEditKeyDown(
      TObject *Sender, WORD &Key, TShiftState Shift)
{
    if(Key == VK_RETURN)
        PridejButtonClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceTypyPokoju::PocetLuzekEditKeyDown(
      TObject *Sender, WORD &Key, TShiftState Shift)
{
    if(Key == VK_RETURN)
        PridejButtonClick(Sender);
}
//---------------------------------------------------------------------------

