//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "DefinovaniCenFile.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDefinovaniCen *DefinovaniCen;
//---------------------------------------------------------------------------

__fastcall TDefinovaniCen::TDefinovaniCen(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TDefinovaniCen::OKButtonClick(TObject *Sender)
{
    SeznamCenPokoju->UlozDoDatabaze();
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TDefinovaniCen::StornoButtonClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------

int TDefinovaniCen::MyShowModal(const vector<int> & _VybraneTypyPokoju)
    // mezilnek ped ShowModal(), aby bylo mon pedat ID typ pokoj,
    // kter uivatel v pedchozm formuli vybral.
    // lo by udlat tak, e tento formul bude sahat na pedchoz, takto
    // se mi to zd ale korektnj.
{
    VybraneTypyPokoju = _VybraneTypyPokoju;
    return ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TDefinovaniCen::FormShow(TObject *Sender)
{
    SeznamTypuDni = new TSeznamTypuDni();
    SeznamTypuKlientu = new TSeznamTypuKlientu();
    SeznamCenPokoju = new TSeznamCenPokoju();
    AktualizujZobrazeniNaFormulari();
}
//---------------------------------------------------------------------------

void TDefinovaniCen::AktualizujZobrazeniNaFormulari(void)
{
    SeznamTypuDni->GetSeznamTStringList(TypyDniListBox->Items);
    SeznamTypuKlientu->GetSeznamTStringList(TypyKlientuListBox->Items);
}
//---------------------------------------------------------------------------

void __fastcall TDefinovaniCen::FormHide(TObject *Sender)
{
    delete SeznamTypuDni;
    delete SeznamTypuKlientu;
    delete SeznamCenPokoju;
}
//---------------------------------------------------------------------------

void __fastcall TDefinovaniCen::NastavCenuButtonClick(TObject *Sender)
    // tri v sobe vnorene cykly zapisuji do SeznamCenPokoju vsechny kombinace
    // vybranch typ pokj, typ dn a typ klient
{
    int AktTypPokojeID;
    int AktTypDneID = -1;
    int AktTypKlientaID = -1;
    double AktCena;

    try
    {
        AktCena = CenaEdit->Text.ToDouble();
    }
    catch(EConvertError &)
    {
        Application->MessageBox("Pole cena neobsahuje platn slo.", "Chyba", MB_OK);
        return;
    }

    vector<int>::iterator ItTypyPokoju;
    for(ItTypyPokoju = VybraneTypyPokoju.begin();
                        ItTypyPokoju != VybraneTypyPokoju.end(); ItTypyPokoju++)
    {
        AktTypPokojeID = *ItTypyPokoju;

        for(int i = 0; i < TypyDniListBox->Items->Count; i++)
        {
            if(TypyDniListBox->Selected[i])
                AktTypDneID = SeznamTypuDni->GetTypDneID(
                                            TypyDniListBox->Items->Strings[i]);
            else
                continue;

            for(int j = 0; j < TypyKlientuListBox->Items->Count; j++)
            {
                if(TypyKlientuListBox->Selected[j])
                    AktTypKlientaID = SeznamTypuKlientu->GetTypKlientaID(
                                        TypyKlientuListBox->Items->Strings[j]);
                else
                    continue;

                SeznamCenPokoju->PridejCenuPokoje(AktTypPokojeID, AktTypKlientaID,
                    AktTypDneID, AktCena);
            }
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TDefinovaniCen::CenaEditKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if(Key == VK_RETURN)
        NastavCenuButtonClick(Sender);
}
//---------------------------------------------------------------------------

