//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TAdministraceSpolupraceSWebem.h"
#include "NovaRezervaceFile.h"
#include "TMojeQuery.h"
#include "TRecepceForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

extern TRecepceForm * RecepceForm;

TNovaRezervace *NovaRezervace;
//---------------------------------------------------------------------------

__fastcall TNovaRezervace::TNovaRezervace(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TNovaRezervace::OKButtonClick(TObject *Sender)
{
    UlozRezervaciDoDatabaze();
    UlozRezervaciNaWebu();
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TNovaRezervace::StornoButtonClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------



void __fastcall TNovaRezervace::FormShow(TObject *Sender)
{
    SeznamKlientu = new TSeznamKlientu();
    ZobrazKlientyComboBox();
    SeznamPokoju = new TSeznamPokoju();
    ZobrazPokojeComboBox();
    ObjednavkaPokoje = 0;
    NastavDatumDateTimePickers();
    AktualizujZobrazeniNaFormulari();
}
//---------------------------------------------------------------------------

void TNovaRezervace::ZobrazKlientyComboBox(void)
{
    SeznamKlientu->GetSeznamTStringList(KlientComboBox->Items);
    KlientComboBox->SetFocus();
    KlientComboBox->DroppedDown = true;
}
//--------------------------------------------------------------------

void TNovaRezervace::ZobrazPokojeComboBox(void)
{
    SeznamPokoju->GetSeznamTStringList(PokojComboBox->Items);
}
//--------------------------------------------------------------------

void TNovaRezervace::NastavDatumDateTimePickers(void)
    // volno z FormShow();
{
    TDate D;
    OdDateTimePicker->Date = D.CurrentDate();
    DoDateTimePicker->Date = D.CurrentDate();
}
//--------------------------------------------------------------------

void TNovaRezervace::UlozRezervaciDoDatabaze(void) const
{
    if(ObjednavkaPokoje && ObjednavkaPokoje->UlozDoDatabaze())
        return; // vsechno v pohode

    Application->MessageBox("Rezervaci nebylo mon uloit.\nNkdo jin prv"
        " uloil jinou kolizn rezervaci?", "Chyba", MB_OK);
}
//-----------------------------------------------------------------------

void TNovaRezervace::UlozRezervaciNaWebu(void) const
    // spust export cen a obsazenosti z TAdministraceSpolupraceSWebem
{
    AdministraceSpolupraceSWebem->ExportCenObsazenostiButtonClick(0);
}
//---------------------------------------------------------------------------

void __fastcall TNovaRezervace::FormHide(TObject *Sender)
{
    delete SeznamKlientu;
    delete SeznamPokoju;
    delete ObjednavkaPokoje;
}
//---------------------------------------------------------------------------

void TNovaRezervace::AktualizujRezervaci(void)
    // pi kad zmn smae stvajc ObjednavkaPokoje, vytvo novou
    // s novmi hodnotami a podle n aktualizuje daje na formuli
{
    delete ObjednavkaPokoje;
    ObjednavkaPokoje = 0;

    if(((int) OdDateTimePicker->Date <= (int) DoDateTimePicker->Date)
        && (KlientComboBox->ItemIndex >= 0) && (PokojComboBox->ItemIndex >= 0))
    {
        TDate D;
        D = D.CurrentDate();
        ObjednavkaPokoje = new TObjednavkaPokoje(
            SeznamKlientu->GetKlientID(
                KlientComboBox->Items->Strings[KlientComboBox->ItemIndex]),
            D, OdDateTimePicker->Date, DoDateTimePicker->Date,
            SeznamPokoju->GetPokojID(
                PokojComboBox->Items->Strings[PokojComboBox->ItemIndex]),
            0);
    }
    AktualizujZobrazeniNaFormulari();
}
//---------------------------------------------------------------------------

void TNovaRezervace::AktualizujZobrazeniNaFormulari(void)
{
    if(ObjednavkaPokoje)
    {
        int Chyba = 0;
        CenaLabel->Caption =
            ObjednavkaPokoje->GetCenuNelzeDohledat()
                ? Chyba++, TMyString("Cena nen pro vybran hodnoty definovna.")
                : TMyString(ObjednavkaPokoje->GetCena());
        VolnyLabel->Caption =
            ObjednavkaPokoje->KolidujeSObjednavkamiVDatabazi()
                ? Chyba++, "Ne"
                : "Ano";
        OKButton->Enabled = Chyba ? false : true;
    }
    else
    {
        CenaLabel->Caption = "Nesprvn zadan daje.";
        VolnyLabel->Caption = "";
        OKButton->Enabled = false;
    }
}
//---------------------------------------------------------------------------

void __fastcall TNovaRezervace::DoDateTimePickerChange(TObject *Sender)
{
    AktualizujRezervaci();
}
//---------------------------------------------------------------------------

void __fastcall TNovaRezervace::OdDateTimePickerChange(TObject *Sender)
{
    AktualizujRezervaci();
}
//---------------------------------------------------------------------------

void __fastcall TNovaRezervace::PokojComboBoxChange(TObject *Sender)
{
    AktualizujRezervaci();
}
//---------------------------------------------------------------------------

void __fastcall TNovaRezervace::KlientComboBoxChange(TObject *Sender)
{
    AktualizujRezervaci();
}
//---------------------------------------------------------------------------

