//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "PridaniKlientaFile.h"
#include "TMojeDatabaze.h"
#include "TTypKlienta.h"
#include "PopisPolozekKlientaFile.h"
#include <vector>
#include "TMojeQuery.h"

using std::vector;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TPridaniKlienta *PridaniKlienta;

extern TMojeDatabaze * MojeDatabaze;
//---------------------------------------------------------------------------

__fastcall TPridaniKlienta::TPridaniKlienta(TComponent* Owner)
    : TForm(Owner)
{

}
//---------------------------------------------------------------------------

void __fastcall TPridaniKlienta::FormShow(TObject *Sender)
{
    SeznamTypuKlientu = new TSeznamTypuKlientu();
    ZobrazTypKlientaComboBox();

    PridejButton->Top = 70;
    StornoButton->Top = 70;
}
//---------------------------------------------------------------------------

void TPridaniKlienta::ZobrazTypKlientaComboBox(void)
    // vol se z "FormShow()", zobraz nabdku typ klient, aby se po vybrn
    // zobrazila jen ta pole k vyplnn, kter pat k pslunmu typu klienta
{
    SeznamTypuKlientu->GetSeznamTStringList(TypKlientaComboBox->Items);
    TypKlientaComboBox->SetFocus();
    if(TypKlientaComboBox->Items->Count > 0)
        TypKlientaComboBox->ItemIndex = 0;
    TypKlientaComboBox->DroppedDown = true;
}
//--------------------------------------------------------------------------

void __fastcall TPridaniKlienta::TypKlientaComboBoxChange(TObject *Sender)
{
    OdstranVytvoreneKomponenty();
    ZobrazVolbyProKlienta(TypKlientaComboBox->Items->Strings[
                                    TypKlientaComboBox->ItemIndex].c_str());
}
//---------------------------------------------------------------------------

void __fastcall TPridaniKlienta::FormHide(TObject *Sender)
{
    delete SeznamTypuKlientu;
    OdstranVytvoreneKomponenty();
}
//---------------------------------------------------------------------------

void TPridaniKlienta::ZobrazVolbyProKlienta(TMyString _TypKlienta)
    // vytvo si TTypKlienta s nzvem _TypKlienta, ten si pi vytven
    // nate z databze, jak poloky se u tohoto typu zobrazuj a podle
    // nich vol funkci "ZobrazVolbu()"
{
    int TypKlientaID = SeznamTypuKlientu->GetTypKlientaID(_TypKlienta);
    TTypKlienta * Zobrazit = new TTypKlienta(TypKlientaID, _TypKlienta);

    int SourLevyHorniRohX = 10;
    int SourLevyHorniRohY = 40;

    if(Zobrazit->FirstZobrazit())
    {
        do
        {
            ZobrazVolbu(SourLevyHorniRohX, SourLevyHorniRohY,
                                Zobrazit->GetNazevPoleZobrazit());
        }
        while(Zobrazit->NextZobrazit());

        PridejButton->Top = SourLevyHorniRohY + 3;
        StornoButton->Top = SourLevyHorniRohY + 3;
    }

    delete Zobrazit;
}
//---------------------------------------------------------------------------

void TPridaniKlienta::OdstranVytvoreneKomponenty()
    // ve "VytvoreneKomponentyLabel" a "VytvoreneKomponentyEdit" shraujeme
    // pointery na naalokovane komponenty, abychom pak mohli uvolnit pam
{
    for(vector<TLabel*>::iterator it = VytvoreneKomponentyLabel.begin();
            it != VytvoreneKomponentyLabel.end(); it++)
    {
        delete *it;
    }
    VytvoreneKomponentyLabel.erase(VytvoreneKomponentyLabel.begin(),
                                                VytvoreneKomponentyLabel.end());

    for(vector< pair<TMyString, TEdit *> >::iterator it
                    = VytvoreneKomponentyEdit.begin();
                                    it != VytvoreneKomponentyEdit.end(); it++)
    {
        delete it->second;
    }
    VytvoreneKomponentyEdit.erase(VytvoreneKomponentyEdit.begin(),
                                                VytvoreneKomponentyEdit.end());
}
//-----------------------------------------------------------------------

void TPridaniKlienta::ZobrazVolbu(int & _lhrX, int & _lhrY,
                                                const TMyString & _NazevPole)
    // Zobraz popis poloky a editan okno na pslun souadnice,
    // aktualizuje Y-souadnici
{
    TLabel * Label = new TLabel(0);
    VytvoreneKomponentyLabel.push_back(Label);
    Label->Parent = PridaniKlienta;
    Label->Left = _lhrX;
    Label->Top = _lhrY;
    Label->Caption = PopisPolozekKlienta.GetPopis(_NazevPole).c_str();

    TEdit * Edit = new TEdit((void *) 0);
    VytvoreneKomponentyEdit.push_back(pair<TMyString, TEdit*>(_NazevPole, Edit));
    Edit->Parent = PridaniKlienta;
    Edit->Left = _lhrX + 100;
    Edit->Top = _lhrY;

    _lhrY += Edit->Height + 2;
}
//--------------------------------------------------------------------------

void __fastcall TPridaniKlienta::StornoButtonClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TPridaniKlienta::PridejButtonClick(TObject *Sender)
{
    UlozKlientaDoDatabaze();
    Close();
}
//---------------------------------------------------------------------------

void TPridaniKlienta::UlozKlientaDoDatabaze(void) const
{
    TMojeQuery * Dotaz = new TMojeQuery(0);

    Dotaz->SQL->Add(VytvorDotazInsert());
    Dotaz->ExecSQL();

    delete Dotaz;
}
//---------------------------------------------------------------------------

TMyString TPridaniKlienta::VytvorDotazInsert(void) const
    // Vyuv ji "UlozKlientaDoDatabaze()"
{
    TMyString Dotaz("INSERT INTO klienti_tab SET");

    for(vector< pair<TMyString, TEdit *> >::const_iterator it
                                = VytvoreneKomponentyEdit.begin();
                                    it != VytvoreneKomponentyEdit.end(); it++)
    {
        Dotaz += TMyString(" ") + it->first + " = \"" + TMyString(it->second->Text) + "\",";
    }

    Dotaz += TMyString(" typ_klienta_id = \"")
            + TMyString(SeznamTypuKlientu->GetTypKlientaID(
              TypKlientaComboBox->Items->Strings[TypKlientaComboBox->ItemIndex]))
            + "\"";

    return Dotaz;
}
//---------------------------------------------------------------------------

