//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TAdministraceSpolupraceSWebem.h"

#include "TMojeQuery.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TAdministraceSpolupraceSWebem *AdministraceSpolupraceSWebem;
//---------------------------------------------------------------------------
__fastcall TAdministraceSpolupraceSWebem::TAdministraceSpolupraceSWebem(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

TMyString TAdministraceSpolupraceSWebem::ExportTypuPokojuVytvorHlavicku(
                                        int _ContentLength) const
    // pro ExportTypuPokojuButtonClick()
{
    return
        TMyString("POST ") + TMyString(AdresarEdit->Text)
                                            + "/typy_pokoju.php HTTP/1.1\n"
        "Accept: text/html, text/plain\n"
        "Content-Type: application/x-www-form-urlencoded\n"
        "User-Agent: Recepce.exe version 1.0\n"
        "Host: " + TMyString(AdresaEdit->Text) + "\n"
        "Content-Length: " + TMyString(_ContentLength) + "\n"
        "Connection: Keep-Alive\n"
        "Cache-Control: no-cache\n";
}
//---------------------------------------------------------------------------

TMyString TAdministraceSpolupraceSWebem::ExportTypuPokojuVytvorParametry(void) const
    // pro ExportTypuPokojuButtonClick()
{
    TMyString Parametry;
    Parametry  = "id=" + TMyString(IDEdit->Text);
    Parametry += TMyString("&heslo=") + TMyString(HesloEdit->Text);

    TMojeQuery * Dotaz = new TMojeQuery();
    Dotaz->SQL->Clear();
    Dotaz->SQL->Add("SELECT typy.typ_pokoje_id, typy.nazev_typu_pokoje, "
        "typy.pocet_luzek , COUNT(*) AS pocet_pokoju FROM typy_pokoju_tab AS typy,"
        " pokoje_tab AS pokoje WHERE pokoje.typ_pokoje_id = typy.typ_pokoje_id"
        " GROUP BY typy.typ_pokoje_id");
    Dotaz->Open();

    Parametry += TMyString("&pocet_typu=") + TMyString(Dotaz->RecordCount);
    if(!Dotaz->IsEmpty())
    {
        Dotaz->First();
        for(int i = 0; i < Dotaz->RecordCount; i++)
        {
            Parametry += TMyString("&typy[") + TMyString(i) + "][typ_pokoje_id]=" +
                     TMyString(Dotaz->FieldByName("typ_pokoje_id")->AsInteger);
            Parametry += TMyString("&typy[") + TMyString(i) + "][nazev_typu_pokoje]=" +
                     TMyString(Dotaz->FieldByName("nazev_typu_pokoje")->AsString);
            Parametry += TMyString("&typy[") + TMyString(i) + "][pocet_luzek]=" +
                     TMyString(Dotaz->FieldByName("pocet_luzek")->AsInteger);
            Parametry += TMyString("&typy[") + TMyString(i) + "][pocet_pokoju]=" +
                     TMyString(Dotaz->FieldByName("pocet_pokoju")->AsInteger);
            Dotaz->Next();
        }
    }
    delete Dotaz;
    return Parametry;
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSpolupraceSWebem::ZavriButtonClick(
      TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSpolupraceSWebem::ExportTypuPokojuButtonClick(
      TObject *Sender)
{
    TMyString Parametry = ExportTypuPokojuVytvorParametry();
    TMyString Hlavicka = ExportTypuPokojuVytvorHlavicku(Parametry.length());
    OdpovedServeruMemo->Lines->Text = "";
    ClientSocket->Socket->SendText(Hlavicka + "\n" + Parametry);
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSpolupraceSWebem::ClientSocketRead(
      TObject *Sender, TCustomWinSocket *Socket)
    // Co pichz ukld do OdpovedServeruMemo a zkou volat
    // ImportRezervaciStart, ten zjist, zda u dolo vechno
    // (konec_dat=true) a podle toho se zachov 
{
    AnsiString AS = OdpovedServeruMemo->Lines->Text;
    AS = AS + ClientSocket->Socket->ReceiveText();
    OdpovedServeruMemo->Lines->Text = AS;

    ImportRezervaciStart();
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSpolupraceSWebem::PripojButtonClick(
      TObject *Sender)
    // pripojuje se k webu. Pokud uz je pripojeno a vyplnena adresa
    // se nezmenila, nic nedela
{
    if((ClientSocket->Host == AdresaEdit->Text) && ClientSocket->Active)
        return;
    if(ClientSocket->Active == true)
        ClientSocket->Active = false;
    ClientSocket->Host = AdresaEdit->Text;
    ClientSocket->Active = true;
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSpolupraceSWebem::PripojenoTimerTimer(TObject *Sender)
    // pouziva ImportRezervaciStart() a ExportCenObsazenostiStart()
    // k pripojeni bez ucasti uzivatele,
    // aby se mohly importovat rezervace i na impuls z webu
{
    if(ClientSocket->Active)
    {
        ImportRezervaciStart();
        ExportCenObsazenostiStart();
    }
    else
    {
        PripojButtonClick(0);
    }
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSpolupraceSWebem::ExportCenObsazenostiButtonClick(
      TObject *Sender)
{
    OdkudPokracovatExportCenObsazenosti = 0;
    ExportCenObsazenostiStart();
}
//---------------------------------------------------------------------------

void TAdministraceSpolupraceSWebem::ExportCenObsazenostiStart(void)
{
    if(OdkudPokracovatExportCenObsazenosti == -1)
        return;

    if(OdkudPokracovatExportCenObsazenosti == 0)
    {
        PripojenoTimer->Enabled = true;
        TMyString Parametry = ExportCenObsazenostiVytvorParametry();
        TMyString Hlavicka = ExportCenObsazenostiVytvorHlavicku(Parametry.length());
        OdpovedServeruMemo->Lines->Text = "";
        if(ClientSocket->Active)
        {
            ClientSocket->Socket->SendText(Hlavicka + "\n" + Parametry);
            OdkudPokracovatExportCenObsazenosti = -1;
            PripojenoTimer->Enabled = false;
        }
    }

    return;
}
//---------------------------------------------------------------------------

TMyString TAdministraceSpolupraceSWebem::ExportCenObsazenostiVytvorHlavicku(
                                        int _ContentLength) const
    // pro ExportCenObsazenostiStart()
{
    return
        TMyString("POST ") + TMyString(AdresarEdit->Text)
                                            + "/ceny_a_obsazenost.php HTTP/1.1\n"
        "Accept: text/html, text/plain\n"
        "Content-Type: application/x-www-form-urlencoded\n"
        "User-Agent: Recepce.exe version 1.0\n"
        "Host: " + TMyString(AdresaEdit->Text) + "\n"
        "Content-Length: " + TMyString(_ContentLength) + "\n"
        "Connection: Keep-Alive\n"
        "Cache-Control: no-cache\n";
}
//---------------------------------------------------------------------------

TMyString TAdministraceSpolupraceSWebem::ExportCenObsazenostiVytvorParametry(void) const
    // pro ExportCenObsazenostiStart()
{
    TMyString Parametry;
    Parametry  = "id=" + TMyString(IDEdit->Text)
            + "&heslo=" + TMyString(HesloEdit->Text);

    TMojeQuery * Dotaz = new TMojeQuery();
    Dotaz->SQL->Clear();
    Dotaz->SQL->Add(
        "SELECT count(distinct objednavky.cislo_objednavky) AS rezervovano,"
        " ceny.typ_pokoje_id, kalendar.datum, ceny.cena FROM"
        " ceny_pokoje_tab AS ceny LEFT JOIN objednavky_pokoje_tab AS objednavky"
        " ON (ceny.typ_pokoje_id = pokoje.typ_pokoje_id AND"
        " pokoje.pokoj_id = objednavky.pokoj_id AND"
        " objednavky.od_kdy <= kalendar.datum AND"
        " objednavky.do_kdy >= kalendar.datum), typy_dnu_tab AS typy,"
        " kalendar_typy_dnu_tab AS kalendar, pokoje_tab AS pokoje WHERE"
        " typy.typ_dne_id = ceny.typ_dne_id AND "
        "typy.typ_dne_id = kalendar.typ_dne_id AND ceny.typ_klienta_id = 1"
                //prvn uloen typ klienta se exportuje do databze na webu
        " AND pokoje.typ_pokoje_id = ceny.typ_pokoje_id AND"
        " kalendar.datum >= CURDATE() AND"
        " kalendar.datum < FROM_DAYS(TO_DAYS(CURDATE()) + 365) GROUP BY"
        " ceny.typ_pokoje_id, kalendar.datum");
    Dotaz->Open();

    Parametry += TMyString("&pocet_zaznamu=") + TMyString(Dotaz->RecordCount);
    if(!Dotaz->IsEmpty())
    {
        Dotaz->First();
        for(int i = 0; i < Dotaz->RecordCount; i++)
        {
            Parametry += TMyString("&ceny[") + TMyString(i) + "][typ_pokoje_id]=" +
                     TMyString(Dotaz->FieldByName("typ_pokoje_id")->AsInteger);
            Parametry += TMyString("&ceny[") + TMyString(i) + "][datum]=" +
                     TMyString(Dotaz->FieldByName("datum")->AsDateTime.FormatString("yyyy-mm-dd"));
            Parametry += TMyString("&ceny[") + TMyString(i) + "][cena]=" +
                     TMyString(Dotaz->FieldByName("cena")->AsFloat);
            Parametry += TMyString("&ceny[") + TMyString(i) + "][rezervovano]=" +
                     TMyString(Dotaz->FieldByName("rezervovano")->AsInteger);
            Dotaz->Next();
        }
    }
    delete Dotaz;
    return Parametry;
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSpolupraceSWebem::ImportRezervaciButtonClick(
      TObject *Sender)
{
    OdkudPokracovat = 0;
    ImportRezervaciStart();
}
//---------------------------------------------------------------------------

void TAdministraceSpolupraceSWebem::ImportRezervaciStart(void)
    // vol ji ImportRezervaciButtonClick nebo se vol kdy nkdo
    // z webu chce potvrdit rezervaci
{
    if(OdkudPokracovat == -1)
        return;

    if(OdkudPokracovat == 0)
    {
        PripojenoTimer->Enabled = true;

        ParametryOdeslatZpetPlatne = false;
            // pokud si je nikdo naposledy nevyzvedl, tak aby si ted nevzal z minula
        ParametryProImport = ImportRezervaciVytvorParametry();
        HlavickaProImport = ImportRezervaciVytvorHlavicku(ParametryProImport.length());
        OdpovedServeruMemo->Lines->Text = "";
        if(ClientSocket->Active)
        {
            ClientSocket->Socket->SendText(HlavickaProImport + "\n" + ParametryProImport);
            OdkudPokracovat = 1;
        }
        return;
    }

    // zde zpracovavame udaje z OdpovedServeruMemo, diky tomu, ze je ReadOnly
    // nemuze nam uzivatel neco vepsat ci umazat

    if(OdkudPokracovat == 1)
    {
        if(!ImportujRezervace(ParametryOdeslatZpetProImport))
        {
            return;
        }

        ParametryProImport  = "id=" + TMyString(IDEdit->Text);
        ParametryProImport += TMyString("&heslo=") + TMyString(HesloEdit->Text);
        ParametryProImport += "&" + ParametryOdeslatZpetProImport;
        HlavickaProImport = ImportRezervaciVytvorHlavicku2(ParametryProImport.length());
        PripojButtonClick(0);
//        OdpovedServeruMemo->Lines->Text = "";
        OdkudPokracovat = 2;
        return;
    }

    if((OdkudPokracovat == 2) && ClientSocket->Active)
    {
        ClientSocket->Socket->SendText(HlavickaProImport + "\n" + ParametryProImport);
        OdkudPokracovat = -1;
        ParametryOdeslatZpetPlatne = true;
            // vyuv se pouze pi voln z loklnho serveru
            // (na webu nkdo prv vypluje rezervaci)

        PripojenoTimer->Enabled = false;
        return;
    }

    return; // sem by to nemlo nikdy dojt
}
//---------------------------------------------------------------------------

TMyString TAdministraceSpolupraceSWebem::ImportRezervaciVytvorHlavicku(
                                        int _ContentLength) const
    // pro ImportRezervaciStart()
{
    return
        TMyString("POST ") + TMyString(AdresarEdit->Text)
                                       + "/rezervace_na_recepci.php HTTP/1.1\n"
        "Accept: text/html, text/plain\n"
        "Content-Type: application/x-www-form-urlencoded\n"
        "User-Agent: Recepce.exe version 1.0\n"
        "Host: " + TMyString(AdresaEdit->Text) + "\n"
        "Content-Length: " + TMyString(_ContentLength) + "\n"
        "Connection: Keep-Alive\n"
        "Cache-Control: no-cache\n";
}
//---------------------------------------------------------------------------

TMyString TAdministraceSpolupraceSWebem::ImportRezervaciVytvorParametry(void) const
    // pro ImportRezervaciStart()
{
    TMyString Parametry;
    Parametry  = "id=" + TMyString(IDEdit->Text)
            + "&heslo=" + TMyString(HesloEdit->Text);

    return Parametry;
}
//---------------------------------------------------------------------------

TMyString TAdministraceSpolupraceSWebem::ImportRezervaciVytvorHlavicku2(
                                        int _ContentLength) const
    // pro ImportRezervaciStart()
{
    return
        TMyString("POST ") + TMyString(AdresarEdit->Text)
                                       + "/rezervace_na_recepci2.php HTTP/1.1\n"
        "Accept: text/html, text/plain\n"
        "Content-Type: application/x-www-form-urlencoded\n"
        "User-Agent: Recepce.exe version 1.0\n"
        "Host: " + TMyString(AdresaEdit->Text) + "\n"
        "Content-Length: " + TMyString(_ContentLength) + "\n"
        "Connection: Keep-Alive\n"
        "Cache-Control: no-cache\n";
}
//---------------------------------------------------------------------------

bool TAdministraceSpolupraceSWebem::ImportujRezervace(TMyString & _Parametry) const
    // Z OdpovedServeruMemo nate daje o novch rezervacch uloench na webu,
    // nekolidujc si ulo a vrt parametry, kter se odelou zpt na server,
    // aby si zapsal, jak rezervace byly akceptovny a jak ne.
    // pokud se ve povede, vrac true
{
    TStrings * Radky = OdpovedServeruMemo->Lines;

    if(Radky->Values["konec_dat"] != "true")
        return false;
    _Parametry = "pocet_rezervaci=" + Radky->Values["pocet_rezervaci"];

    vector< pair< TMyString, TMyString > > Rezervace;
    for(int i = 0; i < Radky->Values["pocet_rezervaci"].ToInt(); i++)
    {
        Rezervace.clear();
        Rezervace.push_back(pair<TMyString, TMyString>("rezervaceid",
                                Radky->Values["rezervaceid" + AnsiString(i)]));
        Rezervace.push_back(pair<TMyString, TMyString>("typ_pokoje_id",
                                Radky->Values["pokojid" + AnsiString(i)]));
                                       // neni pokojid, ale typ_pokoje_id!!

        Rezervace.push_back(pair<TMyString, TMyString>("datum_od",
                                Radky->Values["datum_od" + AnsiString(i)]));
        Rezervace.push_back(pair<TMyString, TMyString>("datum_do",
                                Radky->Values["datum_do" + AnsiString(i)]));
        Rezervace.push_back(pair<TMyString, TMyString>("cena",
                                Radky->Values["cena" + AnsiString(i)]));
        Rezervace.push_back(pair<TMyString, TMyString>("jmeno",
                                Radky->Values["jmeno" + AnsiString(i)]));
        Rezervace.push_back(pair<TMyString, TMyString>("telefon",
                                Radky->Values["telefon" + AnsiString(i)]));
        Rezervace.push_back(pair<TMyString, TMyString>("email",
                                Radky->Values["email" + AnsiString(i)]));
        Rezervace.push_back(pair<TMyString, TMyString>("stat",
                                Radky->Values["stat" + AnsiString(i)]));
        _Parametry += "&";
        _Parametry += ImportujRezervaceZpracujRezervaci(Rezervace);
    }
    return true;
}
//---------------------------------------------------------------------------

TMyString TAdministraceSpolupraceSWebem::ImportujRezervaceZpracujRezervaci(
            const vector< pair<TMyString, TMyString> > & _Rezervace) const
    // Pro ImportujRezervace()
    // ve vectoru _Rezervace dostane informace o rezervaci, kterou nkdo uloil
    // na webu, pokud nekoliduje, tak ji ulo a vrt parametr
    // rezervace[rezervaceid]=1, pokud koliduje, tak neulo a vrt
    // rezervace[rezervaceid]=-1, (toto je pak odeslno zpt na server)
{
    TDate D;
    TObjednavkaPokoje * Objednavka = new TObjednavkaPokoje(
        0, // ID klienta je zatm 0, nevme, zda ho budeme ukldat
        D.CurrentDate(),
        VytvorDatum(NajdiPolozkuZVectoru("datum_od", _Rezervace)),
        VytvorDatum(NajdiPolozkuZVectoru("datum_do", _Rezervace)),
        0,   // pokojid nevime, zname jenom typ
        AnsiString(NajdiPolozkuZVectoru("typ_pokoje_id", _Rezervace).c_str()).ToInt()
             );
    Objednavka->SetCena(
        AnsiString(NajdiPolozkuZVectoru("cena", _Rezervace).c_str()).ToDouble());
    TMyString Vratit = "rezervace[" +
                NajdiPolozkuZVectoru("rezervaceid", _Rezervace) + "]=";
    if(Objednavka->KolidujeSObjednavkamiVDatabazi())
    {
        Vratit += "-1";
        delete Objednavka;
        return Vratit;
    }
    // nyn objednvka nekoliduje, vytvome tedy klienta a pot musme opt
    // zkontrolovat kolizi, kdyby nkdo uloil mezitm dal objednvku
    TKlient * Klient = new TKlient(0, // nov klient
        NajdiPolozkuZVectoru("jmeno", _Rezervace),
        NajdiPolozkuZVectoru("telefon", _Rezervace),
        NajdiPolozkuZVectoru("email", _Rezervace),
        NajdiPolozkuZVectoru("stat", _Rezervace));

    if(UlozKlientaAObjednavku(Klient, Objednavka))
        Vratit += "1";
    else
        Vratit += "-1";

    delete Objednavka;
    delete Klient;

    return Vratit;
}
//---------------------------------------------------------------------------

bool TAdministraceSpolupraceSWebem::UlozKlientaAObjednavku(
        TKlient * _Klient, TObjednavkaPokoje * _Objednavka) const
    // pro ImportujRezervaceZpracujRezervaci()
    // pokud objednavka nekoliduje, ulozi ji i klienta do databaze a
    // vrati true, jinak nic neulozi a vrati false
    // klient ma nastavene KlientID = 0, objednavka take, musi se prenastavit
    // podle databaze.
{
    bool Vratit = false;
    TMojeQuery * Dotaz = new TMojeQuery;
    Dotaz->SQL->Clear();
    Dotaz->SQL->Add("LOCK TABLES klienti_tab WRITE, objednavky_pokoje_tab WRITE");
    Dotaz->ExecSQL();

    if(!_Objednavka->KolidujeSObjednavkamiVDatabazi())
    {
        _Klient->UlozDoDatabaze(Dotaz);
        _Objednavka->SetKlientID(_Klient->GetKlientID());
        _Objednavka->UlozDoDatabaze();
        Vratit = true;
    }

    Dotaz->SQL->Clear();
    Dotaz->SQL->Add("UNLOCK TABLES");
    Dotaz->ExecSQL();
    delete Dotaz;

    return Vratit;
}
//---------------------------------------------------------------------------

TMyString TAdministraceSpolupraceSWebem::NajdiPolozkuZVectoru(TMyString _First,
                const vector< pair<TMyString, TMyString> > & _Vector) const
    // ve vectoru najde na prvnm mst _First a vrt second
    // pedpokld, e se _First ve vect. vyskytuje
{
    for(vector< pair<TMyString, TMyString> >::const_iterator it = _Vector.begin();
            it != _Vector.end(); it++)
    {
        if(it->first == _First)
            return it->second;
    }
    return ""; // sem by to nemelo dojit
}
//---------------------------------------------------------------------------

TDate TAdministraceSpolupraceSWebem::VytvorDatum(const TMyString & _Datum) const
    // dostane datum ve tvaru YYYY-MM-DD a vrt objekt TDate
{
    AnsiString Datum = _Datum.c_str();
    AnsiString Year = Datum.SubString(1, Datum.Pos("-") - 1);
    Datum = Datum.Delete(1, Datum.Pos("-"));
    AnsiString Month = Datum.SubString(1, Datum.Pos("-") - 1);
    AnsiString Day = Datum.Delete(1, Datum.Pos("-"));

    return TDate(Year.ToInt(), Month.ToInt(), Day.ToInt());
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSpolupraceSWebem::FormCreate(TObject *Sender)
{
    OdkudPokracovatExportCenObsazenosti == -1;
        // aby se nerozbehl ExportCenObsazenostiStart()
    OdkudPokracovat = -1; // aby se nerozbhl ImportRezervaciStart()
    ParametryOdeslatZpetPlatne = false;
        // pro funkci GetParametryOdeslatZpetImport()
    PrijatoServerem = new TStringList();
    CekaniNaImportRezervaciTimerCitac = 0;
        // pro funkci CekaniNaImportRezervaciTimerTimer()
}
//---------------------------------------------------------------------------

bool TAdministraceSpolupraceSWebem::GetParametryOdeslatZpetImport(
                        TMyString & _Parametry)
    // vol se z venku po funkci ImportRezervaciStart() pro zjisteni parametru
    // ktere byly odeslany zpet serveru, kvuli zjisteni zda rezervace byla
    // ci nebyla prijata
{
    if(ParametryOdeslatZpetPlatne)
    {
        _Parametry = ParametryOdeslatZpetProImport;
        ParametryOdeslatZpetPlatne = false;
            // parametry lze zjistit jen jednou;
        return true;
    }

    return false;
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSpolupraceSWebem::UlozIPAdresuButtonClick(
      TObject *Sender)
{
    TMyString Parametry = UkladaniIPAdresyVytvorParametry();
    TMyString Hlavicka = UkladaniIPAdresyVytvorHlavicku(Parametry.length());
    OdpovedServeruMemo->Lines->Text = "";
    ClientSocket->Socket->SendText(Hlavicka + "\n" + Parametry);
}
//---------------------------------------------------------------------------

TMyString TAdministraceSpolupraceSWebem::UkladaniIPAdresyVytvorParametry(void) const
    // volano z UlozIPAdresuButtonClick()
{
    TMyString Parametry;
    Parametry  = "id=" + TMyString(IDEdit->Text)
            + "&heslo=" + TMyString(HesloEdit->Text)
            + "&ip_adresa=" + TMyString(LokalniIPEdit->Text);

    return Parametry;
}
//---------------------------------------------------------------------------

TMyString TAdministraceSpolupraceSWebem::UkladaniIPAdresyVytvorHlavicku(
                                        int _ContentLength) const
    // volano z UlozIPAdresuButtonClick()
{
    return
        TMyString("POST ") + TMyString(AdresarEdit->Text)
                                       + "/uloz_ip_adresu.php HTTP/1.1\n"
        "Accept: text/html, text/plain\n"
        "Content-Type: application/x-www-form-urlencoded\n"
        "User-Agent: Recepce.exe version 1.0\n"
        "Host: " + TMyString(AdresaEdit->Text) + "\n"
        "Content-Length: " + TMyString(_ContentLength) + "\n"
        "Connection: Keep-Alive\n"
        "Cache-Control: no-cache\n";
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSpolupraceSWebem::FormDestroy(TObject *Sender)
{
    delete PrijatoServerem;
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSpolupraceSWebem::ServerSocketClientRead(
      TObject *Sender, TCustomWinSocket *Socket)
    // cte co se prijima z webu a uklada do PrijatoServerem a vola
    // OdpovezNaDotazOhledneRezervace(), tam se zkontroluje zda prislo uz
    // vsechno (konec_dat=true) a podle toho se zachova
{
    if(ServerSocket->Socket->ActiveConnections == 0)
        return;

    AnsiString AS = PrijatoServerem->Text;
    AS = AS + ServerSocket->Socket->Connections[0]->ReceiveText();
    PrijatoServerem->Text = AS;

    OdpovezNaDotazOhledneStavuRezervace();
}
//---------------------------------------------------------------------------

void TAdministraceSpolupraceSWebem::OdpovezNaDotazOhledneStavuRezervace(void)
    // provadi import rezervaci stejne, jako kdyby uzivatel zmacknul tlacitko
    // Importuj rezervace, ale na impuls vyplnovane rezervace na webu.
    // pak spusti cekani na import,kde se odpovida, zda byla rezervace
    // prijata ci nikoliv
{
    if(PrijatoServerem->Text.Pos("konec_dat=true") == 0)
        return; // jeste neprislo vsechno
    if(PrijatoServerem->Text.Pos("cislo_rezervace=") == 0)
        return; // nebylo poslno slo rezervace
    CisloRezervace = NajdiParametr("cislo_rezervace", PrijatoServerem->Text);
    SkriptZpet = NajdiParametr("skript_zpet", PrijatoServerem->Text);
    VzhledStranek = NajdiParametr("vzhled_stranek", PrijatoServerem->Text);
    PrijatoServerem->Text = "";
    ImportRezervaciButtonClick(0);
    CekaniNaImportRezervaciTimer->Enabled = true;
}
//---------------------------------------------------------------------------

TMyString TAdministraceSpolupraceSWebem::NajdiParametr(
        const AnsiString & _NazevParametru, AnsiString _Text) const
    // v textu _Text obsahujc parametry tvaru pedvanho metodou GET
    // najde ped rovntkem _NazevParametru a vrt st za rovntkem
{
    int Index = _Text.Pos(_NazevParametru + "=");
    if(Index == 0)
        return ""; // parametr tam neni
    _Text = _Text.Delete(1, Index + _NazevParametru.Length());
        // _Text te zan hodnotou parametru
    Index = _Text.Pos("&");
    if(Index == 0)   // u je to cel hodnota parametru
        return _Text;

    return TMyString(_Text.Delete(Index, _Text.Length() - Index + 1));
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSpolupraceSWebem::CekaniNaImportRezervaciTimerTimer(
      TObject *Sender)
    // pokracovani OdpovezNaDotazOhledneStavuRezervace()
{
    CekaniNaImportRezervaciTimerCitac++;
    TMyString Parametry;
    bool Hotovo = GetParametryOdeslatZpetImport(Parametry);

    if(!Hotovo && (CekaniNaImportRezervaciTimerCitac < 20))
        return;                    // jeste neni hotovo

    CekaniNaImportRezervaciTimer->Enabled = false;
    CekaniNaImportRezervaciTimerCitac = 0;
    if(!Hotovo)
    {           // po dvaceti sekundach se nepovedlo, asi nastala chyba
        Parametry = "chyba=1";
    }
    // v parametrech je bud chyba nebo udaje o rezervacich
    Parametry += TMyString("&cislo_rezervace=") + CisloRezervace +
                "&vzhled_stranek=" + VzhledStranek;
    TMyString  Odeslat = OdpovedNaStavRezervaceVytvorOdpoved(SkriptZpet, Parametry);

    if(ServerSocket->Socket->ActiveConnections > 0)
        ServerSocket->Socket->Connections[0]->SendText(Odeslat);

    ServerSocketDisconnectTimer->Enabled = true;
        // dme serveru jet pr vtein na odesln a rozpojme.
}
//---------------------------------------------------------------------------

TMyString TAdministraceSpolupraceSWebem::OdpovedNaStavRezervaceVytvorOdpoved(
        const TMyString & _JmenoSkriptu, const TMyString & _Parametry) const
    // pro CekaniNaImportRezervaciTimerTimer
{
    return
        TMyString("HTTP/1.1 302 Moved Temporarily\n") +
            "Connection: close\n"
            "Content-type: text/html\n"
            "Expires: Thu, 19 Nov 1981 08:52:00 GMT\n"
            "Cache-Control: no-store, no-cache\n"
            "Pragma: no-cache\n"
            "Location: " + _JmenoSkriptu + "?" + _Parametry + "\n"
            "\n"
            "<html>\n"
            "<head>\n"
            "<title>Pesmrovn</title>\n"
            "</head>\n"
            "<body>\n"
            "	Pokud nebudete automaticky pesmrovni, pokraujte prosm tmto odkazem:<br>\n"
            "	<a href=\"" + _JmenoSkriptu + "?" + _Parametry + "\">Pesmrovn</a>\n"
            "</body>\n"
            "</html>\n";
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSpolupraceSWebem::FormShow(TObject *Sender)
{
    LabelPripojenoTimer->Enabled = true;
        // pravideln kontrola spojen a zobrazen stavu
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSpolupraceSWebem::FormHide(TObject *Sender)
{
    LabelPripojenoTimer->Enabled = false;   
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSpolupraceSWebem::LabelPripojenoTimerTimer(
      TObject *Sender)
    // kontroluje stav pipojen a zobrazuje ho
{
    if(ClientSocket->Active)
    {
        PripojenoLabel->Caption = "Pipojeno";
    }
    else
    {
        PripojenoLabel->Caption = "Odpojeno";
    }

}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSpolupraceSWebem::ServerSocketClientConnect(
      TObject *Sender, TCustomWinSocket *Socket)
    // pokud se chce pripojit nekdo dalsi, odmitne ho.
    //
    // CHTELO BY DODELAT, ABY SE MOHLO ODPOVIDAT NA VICE REZERVACI NAJEDNOU!
{
    if(ServerSocket->Socket->ActiveConnections > 1)
    {
        for(int i = 1; i < ServerSocket->Socket->ActiveConnections; i++)
            ServerSocket->Socket->Connections[i]->Close();
    }
}
//---------------------------------------------------------------------------


void __fastcall TAdministraceSpolupraceSWebem::ServerSocketClientError(
      TObject *Sender, TCustomWinSocket *Socket, TErrorEvent ErrorEvent,
      int &ErrorCode)
    // Nastavujeme ErrorCode = 0, aby se nevyvolala vyjimka
{
    Socket->Close();
    ErrorCode = 0;
}
//---------------------------------------------------------------------------


void __fastcall TAdministraceSpolupraceSWebem::ServerSocketDisconnectTimerTimer(
      TObject *Sender)
    // volano z CekaniNaImportRezervaciTimerTimer()
    // po tom co server odesle udaje o akceptovani ci neakceptovani rezervace
    // se po par vterinach odpoji
{
    if(ServerSocket->Socket->ActiveConnections > 0)
    {
        for(int i = 0; i < ServerSocket->Socket->ActiveConnections; i++)
            ServerSocket->Socket->Connections[i]->Close();
    }
    ServerSocketDisconnectTimer->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TAdministraceSpolupraceSWebem::ClientSocketError(
      TObject *Sender, TCustomWinSocket *Socket, TErrorEvent ErrorEvent,
      int &ErrorCode)
    // Nastavujeme ErrorCode = 0, aby se zabrnilo vyvoln vjimky
{
    Socket->Close();
    ErrorCode = 0;
}
//---------------------------------------------------------------------------

