// Formul, zobraz ho Administrace -> Spoluprce s webem...
//
//---------------------------------------------------------------------------

#ifndef TAdministraceSpolupraceSWebemH
#define TAdministraceSpolupraceSWebemH
//---------------------------------------------------------------------------
#include "TMyString.h"
#include "TKlient.h"
#include "TObjednavkaPokoje.h"

#include <Classes.hpp>
#include <Controls.hpp>
#include <ExtCtrls.hpp>
#include <ScktComp.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <vector>
using MyStd::TMyString;
using std::vector;
using std::pair;
//---------------------------------------------------------------------------
class TAdministraceSpolupraceSWebem : public TForm
{
__published:	// IDE-managed Components
    TButton *ExportTypuPokojuButton;
    TLabel *AdresaLabel;
    TEdit *AdresaEdit;
    TClientSocket *ClientSocket;
    TLabel *AdresarLabel;
    TEdit *AdresarEdit;
    TLabel *OpovedServeruLabel;
    TMemo *OdpovedServeruMemo;
    TButton *ZavriButton;
    TButton *PripojButton;
    TTimer *PripojenoTimer;
    TLabel *PripojenoLabel;
    TButton *ExportCenObsazenostiButton;
    TEdit *IDEdit;
    TEdit *HesloEdit;
    TLabel *IDLabel;
    TLabel *HesloLabel;
    TButton *ImportRezervaciButton;
    TEdit *LokalniIPEdit;
    TLabel *LokalniIPLabel;
    TButton *UlozIPAdresuButton;
    TServerSocket *ServerSocket;
    TTimer *CekaniNaImportRezervaciTimer;
    TTimer *LabelPripojenoTimer;
    TTimer *ServerSocketDisconnectTimer;
    void __fastcall ZavriButtonClick(TObject *Sender);
    void __fastcall ExportTypuPokojuButtonClick(TObject *Sender);
    void __fastcall ClientSocketRead(TObject *Sender,
          TCustomWinSocket *Socket);
    void __fastcall PripojButtonClick(TObject *Sender);
    void __fastcall PripojenoTimerTimer(TObject *Sender);
    void __fastcall ExportCenObsazenostiButtonClick(TObject *Sender);
    void __fastcall ImportRezervaciButtonClick(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall UlozIPAdresuButtonClick(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall ServerSocketClientRead(TObject *Sender,
          TCustomWinSocket *Socket);
    void __fastcall CekaniNaImportRezervaciTimerTimer(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);
    void __fastcall FormHide(TObject *Sender);
    void __fastcall LabelPripojenoTimerTimer(TObject *Sender);
    void __fastcall ServerSocketClientConnect(TObject *Sender,
          TCustomWinSocket *Socket);
    void __fastcall ServerSocketClientError(TObject *Sender,
          TCustomWinSocket *Socket, TErrorEvent ErrorEvent,
          int &ErrorCode);
    void __fastcall ServerSocketDisconnectTimerTimer(TObject *Sender);
    void __fastcall ClientSocketError(TObject *Sender,
          TCustomWinSocket *Socket, TErrorEvent ErrorEvent,
          int &ErrorCode);
private:	// User declarations
    TMyString ExportTypuPokojuVytvorHlavicku(int _ContentLength) const;
    TMyString ExportTypuPokojuVytvorParametry(void) const;
    TMyString ExportCenObsazenostiVytvorHlavicku(int _ContentLength) const;
    TMyString ExportCenObsazenostiVytvorParametry(void) const;
    TMyString ImportRezervaciVytvorHlavicku(int _ContentLength) const;
    TMyString ImportRezervaciVytvorParametry(void) const;
    TMyString ImportRezervaciVytvorHlavicku2(int _ContentLength) const;
    bool ImportujRezervace(TMyString & _Parametry) const;
    TMyString ImportujRezervaceZpracujRezervaci(
            const vector< pair<TMyString, TMyString> > & _Rezervace) const;
    bool UlozKlientaAObjednavku(TKlient * _Klient,
                                    TObjednavkaPokoje * _Objednavka) const;
    TMyString NajdiPolozkuZVectoru(TMyString _First,
                const vector< pair<TMyString, TMyString> > & _Vector) const;
    TDate VytvorDatum(const TMyString & _Datum) const;
    TMyString UkladaniIPAdresyVytvorParametry(void) const;
    TMyString UkladaniIPAdresyVytvorHlavicku(int _ContentLength) const;
    void OdpovezNaDotazOhledneStavuRezervace(void);
    TMyString OdpovedNaStavRezervaceVytvorOdpoved(
        const TMyString & _JmenoSkriptu, const TMyString & _Parametry) const;
    TMyString NajdiParametr(
                  const AnsiString & _NazevParametru, AnsiString _Text) const;
    void ExportCenObsazenostiStart(void);
    int OdkudPokracovatExportCenObsazenosti;

    // vyuv ServerSocket
    void ImportRezervaciStart(void);
    bool GetParametryOdeslatZpetImport(TMyString & _Parametry);
    TStringList * PrijatoServerem;
    int CekaniNaImportRezervaciTimerCitac;
        // ulome a poleme zpt serveru s odpovd
        TMyString CisloRezervace;
        TMyString SkriptZpet;
        TMyString VzhledStranek;

    //*** tyto poloky vyuv ImportRezervaciButtonClick
    //*** musi se v ni cekat na server, tak nemuze mit promenne lokalni
    int OdkudPokracovat;
    TMyString ParametryProImport;
    TMyString HlavickaProImport;
    TMyString ParametryOdeslatZpetProImport;
    bool ParametryOdeslatZpetPlatne;
    //*********************
public:		// User declarations
    __fastcall TAdministraceSpolupraceSWebem(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TAdministraceSpolupraceSWebem *AdministraceSpolupraceSWebem;
//---------------------------------------------------------------------------
#endif
