#include "TKalendarProTypDne.h"

#include "TMojeQuery.h"
#include "TMyString.h"

#include <algorithm>

using std::find;
using MyStd::TMyString;
//-------------------------------------------------------------------------

TKalendarProTypDne::TKalendarProTypDne(int _TypDneID)
    // nate si z databze daje a ulo do set<> Dny
{
    TypDneID = _TypDneID;

    TMojeQuery * DotazDny = new TMojeQuery();
    DotazDny->SQL->Add(
        TMyString("SELECT * FROM kalendar_typy_dnu_tab WHERE typ_dne_id = \"")
                                                + TMyString(TypDneID) + "\"");
    DotazDny->Open();

    Dny.clear();
    if(!DotazDny->IsEmpty())
    {
        DotazDny->First();
        do
        {   Dny.insert(set< TDate >::value_type(
                                DotazDny->FieldByName("datum")->AsDateTime
                                                                            ));
            DotazDny->Next();
        }
        while(!DotazDny->Eof);
    }
    delete DotazDny;
}
//-------------------------------------------------------------------------

void TKalendarProTypDne::GetSeznamTStringList(TStrings * _sl) const
    // do seznamu TStrings pedanho pes pointer zape textov data
    // z set<> Dny, co tam bylo pedtm smae
{
    set< TDate >::const_iterator it;

    _sl->Clear();

    for(it = Dny.begin(); it != Dny.end(); it++)
    {
        _sl->Add(*it); // TDate obsahuje operator AnsiString()
    }
}
//------------------------------------------------------------------------

void TKalendarProTypDne::PridejDatum(const TDate & _Datum)
    // pid datum _Datum, pokud u je, nic nedl
{
    TDate Datum = TDate(int(_Datum));
        // odzneme desetinnou st, aby se nezobrazovaly hodiny, jen dny
    set< TDate >::iterator it = find(Dny.begin(), Dny.end(), Datum);
    if(it == Dny.end()) //datum jeste neni v Dny
    {
        Dny.insert(Datum);
    }
}
//------------------------------------------------------------------------

void TKalendarProTypDne::OdstranDatum(const TMyString & _Datum)
    // odstran datum, pokud tam nen, nedl nic
{
    TDate Datum = TDate(_Datum);
    set< TDate >::iterator it = find(Dny.begin(), Dny.end(), Datum);
    if(it != Dny.end())
    {
        Dny.erase(it);
    }
}
//-------------------------------------------------------------------------

void TKalendarProTypDne::UlozDoDatabaze(void)
    // Ulo set<> Dny do databze
    // chtlo by upravit, zlohovat data v databzi, ne se zane ukldat
{
    TMojeQuery * Dotaz = new TMojeQuery();

    Dotaz->SQL->Clear();
    Dotaz->SQL->Add("LOCK TABLES kalendar_typy_dnu_tab WRITE");
    Dotaz->ExecSQL();

    Dotaz->SQL->Clear();
    Dotaz->SQL->Add(TMyString("DELETE FROM kalendar_typy_dnu_tab WHERE typ_dne_id = \"")
                        + TMyString(TypDneID) + "\"");
    Dotaz->ExecSQL();

    set< TDate >::iterator it;
    for(it = Dny.begin(); it != Dny.end(); it++)
    {
        TMyString DotazStr = VytvorDotazInsertProUlozeniDne(it);
        Dotaz->SQL->Clear();
        Dotaz->SQL->Add(DotazStr);
        Dotaz->ExecSQL();
    }

    Dotaz->SQL->Clear();
    Dotaz->SQL->Add("UNLOCK TABLES");
    Dotaz->ExecSQL();

    delete Dotaz;
}
//-----------------------------------------------------------------------

TMyString TKalendarProTypDne::VytvorDotazInsertProUlozeniDne(
                                            const set< TDate >::iterator _it)
    // vyuv ji UlozDoDatabaze()
{
    return
        TMyString("INSERT INTO kalendar_typy_dnu_tab SET ")
        + "datum = \""
        + _it->FormatString("yyyy-mm-dd")
        + "\", typ_dne_id = \""
        + TMyString(TypDneID)
        + "\"";
}
//------------------------------------------------------------------------

