// Tda reprezentujc jeden zznam z tabulky objednavky_pokoje_tab
//--------------------------------------------------------------------------
#ifndef _TObjednavkaPokoje_h_
#define _TObjednavkaPokoje_h_
//--------------------------------------------------------------------------
#include "TMyString.h"
#include "TMojeQuery.h"
#include <Controls.hpp>

using MyStd::TMyString;
//--------------------------------------------------------------------------

class TObjednavkaPokoje
{
public:
    TObjednavkaPokoje(int _KlientID, int _CisloObjednavky,
        const TDate & _DatumObjednavky, const TDate & _OdKdy,
        const TDate & _DoKdy, int _PokojID, double _Cena);
    TObjednavkaPokoje(int _KlientID, const TDate & _DatumObjednavky,
        const TDate & _OdKdy, const TDate & _DoKdy, int _PokojID, int _TypPokojeID);
    ~TObjednavkaPokoje(void) {};
    bool KolidujeSObjednavkamiVDatabazi(TMojeQuery * _Dotaz = 0) const;
    bool UlozDoDatabaze(TMojeQuery * _Dotaz = 0) const;
    int GetKlientID(void) const { return KlientID; };
    bool GetCenuNelzeDohledat(void) const  { return CenuNelzeDohledat; };
    double GetCena(void) const { return Cena; };
    int GetCisloObjednavky(void) const { return CisloObjednavky; };
    TDate GetOdKdy(void) const { return OdKdy; };
    TDate GetDoKdy(void) const { return DoKdy; };
    void SetKlientID(int _KlientID) { KlientID = _KlientID; };
    void SetCena(double _Cena) { Cena = _Cena; };

private:
    TMyString VytvorDotazInsertProUlozeni(void) const;
    int NajdiDalsiCisloObjednavky(void) const;
    double NajdiCenuPokojeOdDo(int _KlientID, int _PokojID,
              const TDate & _OdKdy, const TDate & _DoKdy, bool & _Chyba) const;
    double NajdiCenuPokoje(int _KlientID, int _PokojID,
                                    const TDate & _Datum, bool & _Chyba) const;
    TMyString VytvorDotazNajdiCenuPokoje(int _KlientID, int _PokojID,
                                                const TDate & _Datum) const;
    int NajdiVolnyPokojPodleTypu(int _TypPokojeID,
                          const TDate & _OdKdy, const TDate & _DoKdy) const;
    TMyString VytvorDotazNajdiVolnyPokojPodleTypu(int _TypPokojeID,
            const TMyString & _OdKdy, const TMyString & _DoKdy) const;

    int KlientID;
    int CisloObjednavky; // pokud je 0, jedn se o novou objednvku a cislo
                         // se dohleda az pri ukladani do databaze
    TDate DatumObjednavky;
    TDate OdKdy;
    TDate DoKdy;
    int PokojID;
    double Cena;
    bool CenuNelzeDohledat; // indikuje, zda se pro tuto objednvku v tabulce
                            // ceny_pokoje_tab nalzaj dostaten informace
};
//--------------------------------------------------------------------------

#endif
