#include "TPokoj.h"

#include "TRecepceForm.h"
//---------------------------------------------------------------------------

TPokoj::TPokoj(int _PokojID, const TMyString & _CisloPokoje, int _TypPokojeID)
{
    PokojID = _PokojID;
    CisloPokoje = _CisloPokoje;
    TypPokojeID = _TypPokojeID;
}
//---------------------------------------------------------------------------

bool TPokoj::operator==(const TPokoj & _RHS) const
{
    if(PokojID == _RHS.GetPokojID())
        return true;
    else
        return false;
}
//---------------------------------------------------------------------------

bool TPokoj::operator!=(const TPokoj & _RHS) const
{
    if(!operator==(_RHS))
        return true;
    else
        return false;
}
//---------------------------------------------------------------------------

void TPokoj::ZobrazLabelCisloPokoje(const TControl *_Parent, int _lhrX,
    int _lhrY, TSeznamVytvorenychKomponent * _SeznamVytvorenychKomponent) const
    // na komponentu _Parent na pozici _lhrX, _lhrY umst TLabel s Caption
    // obsahujc sloPokoje, pointer na vytvoen Label vlo do
    // _SeznamVytvorenychKomponent
{
    TLabel * CisloPokojeLabel = new TLabel(0);
    _SeznamVytvorenychKomponent->PridejKomponentu(CisloPokojeLabel);

    CisloPokojeLabel->Parent = (TWinControl *) _Parent;
    CisloPokojeLabel->Left = _lhrX;
    CisloPokojeLabel->Top = _lhrY;
    CisloPokojeLabel->Caption = CisloPokoje;
}
//--------------------------------------------------------------------------

void TPokoj::ZobrazObsazenostPokojeOdDo(const TControl * _Parent, int _lhrX,
    int _lhrY, int MezeryX, const TDate & _Od, const TDate & _Do,
        TSeznamVytvorenychKomponent * _SeznamVytvorenychKomponent) const
    // na komponentu _Parent od pozice _lhrX, _lhrY umst znaky identifikujc
    // zda je pokoj voln i ne v obdob od _Od do _Do, mezery mezi znakami
    // vkld takov, kolik je MezeryX
    // pointer na vytvoen komponenty vlo do _SeznamVytvorenychKomponent
{
    TMojeQuery * Dotaz = new TMojeQuery();
        // alokujeme uz tady, aby se to v ZobrazObsazenostPokoje() nezdrzovalo

    for(TDate D = _Od; (int) D <= (int) _Do; D++) // mus bt (int), desetinn
                                           // st se toti nemus shodovat
    {
        ZobrazObsazenostPokoje(Dotaz, _Parent, _lhrX, _lhrY, D,
                                            _SeznamVytvorenychKomponent);
        _lhrX += MezeryX;
    }

    delete Dotaz;
}
//--------------------------------------------------------------------------

void TPokoj::ZobrazObsazenostPokoje(TMojeQuery * _Dotaz, const TControl * _Parent, int _lhrX,
            int _lhrY, const TDate & _Datum,
            TSeznamVytvorenychKomponent * _SeznamVytvorenychKomponent) const
    // na komponentu _Parent na pozici _lhrX, _lhrY umst znaku identifikujc
    // zda je pokoj voln i ne dne _Datum
    // pointer na vytvoen komponenty vlo do _SeznamVytvorenychKomponent
{
    _Dotaz->SQL->Clear();
    _Dotaz->SQL->Add(TMyString("SELECT pokoj_id FROM objednavky_pokoje_tab"
        " WHERE pokoj_id = \"") + TMyString(PokojID) + "\" AND od_kdy <= \"" +
        TMyString(_Datum) + "\" AND do_kdy >= \"" + TMyString(_Datum) + "\"");
    _Dotaz->Open();

    if(_Dotaz->IsEmpty()) // pokoj je voln
    {
        VykresliZnacku(0, _Parent, _lhrX, _lhrY, _SeznamVytvorenychKomponent);
    }
    else // pokoj je obsazen
    {
        VykresliZnacku(1, _Parent, _lhrX, _lhrY, _SeznamVytvorenychKomponent);
    }
}
//--------------------------------------------------------------------------

void TPokoj::VykresliZnacku(int _StavPokoje, const TControl * _Parent, int _lhrX,
    int _lhrY, TSeznamVytvorenychKomponent * _SeznamVytvorenychKomponent) const
    // volano z ZobrazObsazenostPokoje()
    // na dan souadnice, formul _Parent vykresl tvereek odpovdajc
    // obsazenosti a pointer na nj vlo do _SeznamVytvorenychKomponent
    // _StavPokoje - 0 - volno, 1 - obsazeno
{
    TImage * Ctverecek = new TImage(0);
    _SeznamVytvorenychKomponent->PridejKomponentu(Ctverecek);

    RecepceForm->CtvereckyImageList->GetBitmap(_StavPokoje, Ctverecek->Picture->Bitmap);
    Ctverecek->Parent = (TWinControl *) _Parent;
    Ctverecek->Left = _lhrX;
    Ctverecek->Top = _lhrY;
    Ctverecek->Width = Ctverecek->Picture->Width;
    Ctverecek->Height = Ctverecek->Picture->Bitmap->Height;
}
//--------------------------------------------------------------------------

