// Vyuv ji "TSeznamPokoju", reprezentuje jednu dku v tabulce "pokoje_tab"
//
// opertory !=, == porovnvaj pouze podle ID pokoje
//---------------------------------------------------------------------------
#ifndef _TPokoj_h_
#define _TPokoj_h_

#include "TSeznamVytvorenychKomponent.h"
#include "TMojeQuery.h"
#include "TMyString.h"

using MyStd::TMyString;
//---------------------------------------------------------------------------

class TPokoj
{
public:
    TPokoj(int _PokojID, const TMyString & _CisloPokoje, int _TypPokojeID);
    ~TPokoj(void) {};
    int GetPokojID(void) const { return PokojID; };
    const TMyString & GetCisloPokoje(void) const { return CisloPokoje; };
    int GetTypPokojeID(void) const { return TypPokojeID; };
    bool operator==(const TPokoj & _RHS) const; // dv se jan na PokojID
    bool operator!=(const TPokoj & _RHS) const; // dv se jen na PokojID
    void ZobrazLabelCisloPokoje(const TControl *_Parent, int _lhrX, int _lhrY,
                TSeznamVytvorenychKomponent * _SeznamVytvorenychKomponent) const;
    void ZobrazObsazenostPokojeOdDo(const TControl * _Parent, int _lhrX, int _lhrY,
                        int MezeryX, const TDate & _Od, const TDate & _Do,
                        TSeznamVytvorenychKomponent * _SeznamVytvorenychKomponent) const;

private:
    void ZobrazObsazenostPokoje(TMojeQuery * _Dotaz, const TControl * _Parent,
            int _lhrX, int _lhrY, const TDate & _Datum,
            TSeznamVytvorenychKomponent * _SeznamVytvorenychKomponent) const;
    void VykresliZnacku(int _StavPokoje, const TControl * _Parent, int _lhrX,
        int _lhrY, TSeznamVytvorenychKomponent * _SeznamVytvorenychKomponent) const;

    int PokojID;
    TMyString CisloPokoje;
    int TypPokojeID;
};
//---------------------------------------------------------------------------

#endif
