//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TRecepceForm.h"
#include "AdministracePokojeFile.h"
#include "AdministraceSkupinyPokojuFile.h"
#include "AdministraceTypyPokojuFile.h"
#include "AdministraceTypyDniFile.h"
#include "PridaniKlientaFile.h"
#include "NovaRezervaceFile.h"
#include "KlientiUpravUdajeFile.h"
#include "TRezervaceSmazRezervaci.h"
#include "TAboutBox.h"
#include "TAdministraceSpolupraceSWebem.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SHDocVw_OCX"
#pragma resource "*.dfm"
TRecepceForm *RecepceForm;

//---------------------------------------------------------------------------

__fastcall TRecepceForm::TRecepceForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TRecepceForm::MenuAdministracePokojeClick(TObject *Sender)
{
    AdministracePokoje->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TRecepceForm::MenuAdministraceSkupinyPokojuClick(TObject *Sender)
{
    AdministraceSkupinyPokoju->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TRecepceForm::MenuAdministraceTypyPokojuClick(TObject *Sender)
{
    AdministraceTypyPokoju->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TRecepceForm::MenuKlientiNovyKlientClick(TObject *Sender)
{
    PridaniKlienta->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TRecepceForm::FormCreate(TObject *Sender)
{
    MojeDatabaze = new TMojeDatabaze(RecepceForm);
    try
    {
        MojeDatabaze->Open();
    }
    catch (...)
    {
        Application->MessageBox("Nepodailo se pipojit k databzi.",
            "Chyba", MB_OK);
        MojeDatabaze = 0;
        return;
    }
    SeznamSkupinPokoju = new TSeznamSkupinPokoju();
    SeznamVytvorenychKomponent = new TSeznamVytvorenychKomponent();
}
//---------------------------------------------------------------------------

void __fastcall TRecepceForm::MenuRezervaceNovaRezervaceClick(TObject *Sender)
{
    NovaRezervace->ShowModal();
    ZobrazObsazenostPokoju(); // s novou rezervaci muze byt potreba aktualizovat
}
//---------------------------------------------------------------------------

void __fastcall TRecepceForm::FormDestroy(TObject *Sender)
{
    delete MojeDatabaze;
    delete SeznamSkupinPokoju;
    delete SeznamVytvorenychKomponent;
}
//---------------------------------------------------------------------------

void __fastcall TRecepceForm::MenuAdministraceTypyDniClick(TObject *Sender)
{
    AdministraceTypyDni->ShowModal();
}
//---------------------------------------------------------------------------

void TRecepceForm::AktualizujZobrazeniNaFormulari(void)
{
    TDate D;
    OdDateTimePicker->Date = D.CurrentDateTime();
    DoDateTimePicker->Date = 29 + OdDateTimePicker->Date;// na zatku zobrazme
                                    // msc (30 dn) ode dneka

    SeznamSkupinPokoju->GetSeznamTStringList(ObsazenostPokojuTabControl->Tabs);
    ZobrazObsazenostPokoju();
}
//--------------------------------------------------------------------------
void __fastcall TRecepceForm::FormShow(TObject *Sender)
{
    if(!MojeDatabaze) // nepodailo se pipojit k databzi, pravdpodobn
        Close();        // patn zadan jmno nebo heslo, nebo nedostupn databze
    else
        AktualizujZobrazeniNaFormulari();
}
//---------------------------------------------------------------------------

void TRecepceForm::ZobrazObsazenostPokoju(void) const
    // zobraz nzvy pokoj, data, dny v tdnu a tvereky obsazenosti
    // pro uivatelem vybranou skupinu pokoj
{
    int Dni = 1 + (int) DoDateTimePicker->Date - (int) OdDateTimePicker->Date;
        // mus bt cast na int, desetinn st dne Do me bt men ne dne Od
    SeznamVytvorenychKomponent->OdstranVse();

    if(Dni > 60)
    {
        Application->MessageBox(TMyString(TMyString("Poadujete zobrazit ")
            + TMyString(Dni) + " dn.\nMaximln lze zobrazit 60 dn, doporueno"
            " je 30.").c_str(), "Velk asov rozpt", MB_OK);
            return;
    }
    if(Dni > 30)
        if(Application->MessageBox(TMyString(TMyString("Poadujete zobrazit ")
            + TMyString(Dni) + " dn.\nAkce me trvat dlouho. Chcete pokraovat?").c_str(),
            "Varovn", MB_OKCANCEL) == IDCANCEL)
            return;

    if((Dni > 0) && (ObsazenostPokojuTabControl->TabIndex >= 0))
    {
        ZobrazObsazenostPokojuProSkupinu(
            ObsazenostPokojuTabControl->Tabs->Strings[
                                        ObsazenostPokojuTabControl->TabIndex]);
    }
}
//---------------------------------------------------------------------------

void TRecepceForm::ZobrazObsazenostPokojuProSkupinu(const TMyString & _SkupinaPokoju) const
    // volano ze ZobrazObsazenostPokoju()
    // Zobraz popisy pokoj, data, dny v tdnu a tvereky pro skupinu
    // pokoj _SkupnaPokoju na formuli
{
        SeznamSkupinPokoju->ZobrazObsazenostPokojuProSkupinu(_SkupinaPokoju,
            RecepceForm, 10, 2 + ObsazenostPokojuTabControl->Top +
            ObsazenostPokojuTabControl->Height, OdDateTimePicker->Date,
            DoDateTimePicker->Date, SeznamVytvorenychKomponent);
}
//---------------------------------------------------------------------------

void __fastcall TRecepceForm::ObsazenostPokojuTabControlChange(
      TObject *Sender)
{
    ZobrazObsazenostPokoju();
}
//---------------------------------------------------------------------------

void __fastcall TRecepceForm::ZobrazButtonClick(TObject *Sender)
{
    ZobrazObsazenostPokoju();
}
//---------------------------------------------------------------------------

void __fastcall TRecepceForm::MenuKlientiUpravUdajeClick(TObject *Sender)
{
    KlientiUpravUdaje->ShowModal();    
}
//---------------------------------------------------------------------------

void __fastcall TRecepceForm::SmazRezervaciClick(TObject *Sender)
{
    RezervaceSmazRezervaci->ShowModal();
    ZobrazObsazenostPokoju();    
}
//---------------------------------------------------------------------------

void __fastcall TRecepceForm::OAplikaciClick(TObject *Sender)
{
    AboutBox->ShowModal();    
}
//---------------------------------------------------------------------------

void __fastcall TRecepceForm::SpolupraceSWebemClick(TObject *Sender)
{
    AdministraceSpolupraceSWebem->ShowModal();
}
//---------------------------------------------------------------------------


