//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TRezervaceSmazRezervaci.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TRezervaceSmazRezervaci *RezervaceSmazRezervaci;
//---------------------------------------------------------------------------
__fastcall TRezervaceSmazRezervaci::TRezervaceSmazRezervaci(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TRezervaceSmazRezervaci::FormShow(TObject *Sender)
{
    SeznamKlientu = new TSeznamKlientu();
    SeznamKlientu->GetSeznamTStringList(KlientComboBox->Items);
    SeznamObjednavekPokoju = 0;
}
//---------------------------------------------------------------------------

void __fastcall TRezervaceSmazRezervaci::FormHide(TObject *Sender)
{
    delete SeznamKlientu;
    delete SeznamObjednavekPokoju;
}
//---------------------------------------------------------------------------

void __fastcall TRezervaceSmazRezervaci::KlientComboBoxChange(
      TObject *Sender)
    // smae SeznamObjednavekPokoju a vytvo nov pro prv vybranho klienta
{
    delete SeznamObjednavekPokoju;

    if(KlientComboBox->ItemIndex >= 0)
    {
        SeznamObjednavekPokoju = new TSeznamObjednavekPokoju(
            SeznamKlientu->GetKlientID(
                KlientComboBox->Items->Strings[KlientComboBox->ItemIndex]));
        SeznamObjednavekPokoju->GetSeznamTStringList(RezervaceListBox->Items);
    }
    AktualizujZobrazeniNaFormulari();
}
//---------------------------------------------------------------------------

void __fastcall TRezervaceSmazRezervaci::OKButtonClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TRezervaceSmazRezervaci::StornoButtonClick(TObject *Sender)
    // v souasnosti neaktivn tlatko
{
    Close();
}
//---------------------------------------------------------------------------

void TRezervaceSmazRezervaci::AktualizujZobrazeniNaFormulari(void)
{
    if(SeznamObjednavekPokoju && (RezervaceListBox->ItemIndex >= 0))
    {
        OdLabel->Caption = TMyString(SeznamObjednavekPokoju->GetOdKdy(
            RezervaceListBox->Items->Strings[RezervaceListBox->ItemIndex].ToInt()));
        DoLabel->Caption = TMyString(SeznamObjednavekPokoju->GetDoKdy(
            RezervaceListBox->Items->Strings[RezervaceListBox->ItemIndex].ToInt()));
    }
    else
    {
        OdLabel->Caption = "";
        DoLabel->Caption = "";
    }
}
//---------------------------------------------------------------------------

void __fastcall TRezervaceSmazRezervaci::RezervaceListBoxClick(
      TObject *Sender)
{
    AktualizujZobrazeniNaFormulari();
}
//---------------------------------------------------------------------------

void __fastcall TRezervaceSmazRezervaci::SmazRezervaciButtonClick(
      TObject *Sender)
    // smae vybranou rezervaci pmo z databze
    // chtlo by vylepit, aby bylo mono pouvat tlatko storno
{
    if(RezervaceListBox->ItemIndex == -1)
        return;

    if(Application->MessageBox("Opravdu chcete rezervaci trvale smazat?",
        "Varovn", MB_OKCANCEL) == IDOK)
    {
        SmazRezervaciZDatabaze(RezervaceListBox->Items->Strings[
                RezervaceListBox->ItemIndex].ToInt());

        KlientComboBoxChange(Sender); // aby se aktualizoval formular
    }
}
//---------------------------------------------------------------------------

void TRezervaceSmazRezervaci::SmazRezervaciZDatabaze(int _CisloObjednavky) const
    // volano z SmazRezervaciButtonClick()
{
    TMojeQuery * Dotaz = new TMojeQuery();

    Dotaz->SQL->Clear();
    Dotaz->SQL->Add(TMyString(
        "DELETE FROM objednavky_pokoje_tab WHERE cislo_objednavky = \"")
                                + TMyString(_CisloObjednavky) + "\"");
    Dotaz->ExecSQL();

    delete Dotaz;
}
//---------------------------------------------------------------------------

