#include "TSeznamCenPokoju.h"

#include "TMojeQuery.h"

//---------------------------------------------------------------------------

TSeznamCenPokoju::TSeznamCenPokoju(void)
{
    TMojeQuery * DotazCenyPokoju = new TMojeQuery();

    DotazCenyPokoju->SQL->Add("SELECT * FROM ceny_pokoje_tab");
    DotazCenyPokoju->Open();

    CenyPokoju.clear();
    if(!DotazCenyPokoju->IsEmpty())
    {
        DotazCenyPokoju->First();
        do
        {
            CenyPokoju.insert(TCenaPokoje(
                DotazCenyPokoju->FieldByName("typ_pokoje_id")->AsInteger,
                DotazCenyPokoju->FieldByName("typ_klienta_id")->AsInteger,
                DotazCenyPokoju->FieldByName("typ_dne_id")->AsInteger,
                DotazCenyPokoju->FieldByName("cena")->AsFloat
                                                                            ));
            DotazCenyPokoju->Next();
        }
        while(!DotazCenyPokoju->Eof);
    }

    delete DotazCenyPokoju;
}
//---------------------------------------------------------------------------

void TSeznamCenPokoju::UlozDoDatabaze(void)
    // ulo zmny ve "CenyPokoju" do databaze, chtlo by vylepit,
    // ne se zane nco dlat, tak data zlohovat
{
    TMojeQuery * Dotaz = new TMojeQuery();

    Dotaz->SQL->Clear();
    Dotaz->SQL->Add("LOCK TABLES ceny_pokoje_tab WRITE");
    Dotaz->ExecSQL();

    Dotaz->SQL->Clear();
    Dotaz->SQL->Add("DELETE FROM ceny_pokoje_tab");
    Dotaz->ExecSQL();

    set< TCenaPokoje >::const_iterator it;
    for(it = CenyPokoju.begin(); it != CenyPokoju.end(); it++)
    {
        Dotaz->SQL->Clear();
        Dotaz->SQL->Add(VytvorDotazInsertProUlozeniCenyPokoje(it));
        Dotaz->ExecSQL();
    }

    Dotaz->SQL->Clear();
    Dotaz->SQL->Add("UNLOCK TABLES");
    Dotaz->ExecSQL();

    delete Dotaz;
}
//---------------------------------------------------------------------------

TMyString TSeznamCenPokoju::VytvorDotazInsertProUlozeniCenyPokoje(
                        const set< TCenaPokoje >::const_iterator _it) const
    // Vyuv ji "UlozDoDatabaze()"
{
    return
        TMyString("INSERT INTO ceny_pokoje_tab SET ")
        + "typ_pokoje_id = \""
        + TMyString(_it->GetTypPokojeID())
        + "\", typ_klienta_id = \""
        + TMyString(_it->GetTypKlientaID())
        + "\", typ_dne_id = \""
        + TMyString(_it->GetTypDneID())
        + "\", cena = \""
        + TMyString(_it->GetCena())
        + "\"";
}
//------------------------------------------------------------------------

void TSeznamCenPokoju::OdstranCenuPokoje(
                            int _TypPokojeID, int _TypKlientaID, int _TypDneID)
    // odebere z "CenyPokoju" zaznam o cene pro dany typ pokoje, typ klienta
    // a typ dne, pokud tam neni, nic neudela
{
    set< TCenaPokoje >::iterator it;
    for(it = CenyPokoju.begin(); it != CenyPokoju.end(); it++)
    {
        if((it->GetTypPokojeID() == _TypPokojeID)
                && (it->GetTypKlientaID() == _TypKlientaID )
                && (it->GetTypDneID() == _TypDneID))
        {
            CenyPokoju.erase(it);
            break; // mel by tam byt jenom jeden, nema smysl pokracovat
        }
    }

}
//--------------------------------------------------------------------------

void TSeznamCenPokoju::PridejCenuPokoje(
            int _TypPokojeID, int _TypKlientaID, int _TypDneID, double _Cena)
    // do "CenyPokoju" prida cenu k danemu typu pokoje, typu klienta a typu
    // dne, pokud tam uz nejaka je, tak ji prepise
{
    TCenaPokoje CenaPokoje = TCenaPokoje(_TypPokojeID, _TypKlientaID,
                                                            _TypDneID, _Cena);
    set< TCenaPokoje >::iterator it = find(CenyPokoju.begin(), CenyPokoju.end(),
                                                                CenaPokoje);
    if(it != CenyPokoju.end())  
        CenyPokoju.erase(it); //pokud tam neco bylo, smazeme to, cena nas nezajima
    CenyPokoju.insert(CenaPokoje);
}
//---------------------------------------------------------------------------

