#include "TSeznamPokoju.h"

#include "TMojeQuery.h"
//---------------------------------------------------------------------------

TSeznamPokoju::TSeznamPokoju(void)
    // nate z databze daje o pokojch a vypln jimi vector "Pokoje"
{
    TMojeQuery * DotazPokoje = new TMojeQuery();

    DotazPokoje->SQL->Add("SELECT * FROM pokoje_tab");
    DotazPokoje->Open();

    Pokoje.clear();

    if(!DotazPokoje->IsEmpty())
    {
        DotazPokoje->First();
        do
        {
            Pokoje.push_back(vector< TPokoj >::value_type(
                DotazPokoje->FieldByName("pokoj_id")->AsInteger,
                TMyString(DotazPokoje->FieldByName("cislo_pokoje")->AsString),
                DotazPokoje->FieldByName("typ_pokoje_id")->AsInteger
                                                                                    ));
            DotazPokoje->Next();
        }
        while(!DotazPokoje->Eof);
    }

    delete DotazPokoje;
}
//---------------------------------------------------------------------------

void TSeznamPokoju::GetSeznamTStringList(TStrings * _sl) const
    // do pedanho pointeru ukazujcho na TStrings vypln
    // sla pokoj, ve co tam bylo pedtm odstran
{
    vector< TPokoj >::const_iterator it;

    _sl->Clear();

    for(it = Pokoje.begin(); it != Pokoje.end(); it++)
    {
        _sl->Add(it->GetCisloPokoje());
    }
}
//-------------------------------------------------------------

void TSeznamPokoju::PridejPokoj(const TMyString & _CisloPokoje, int _TypPokojeID)
    // pid pokoj do vectoru "Pokoje", je volno z "TAdministracePokoje"
{
    Pokoje.push_back(TPokoj(NajdiNepouziteID(), _CisloPokoje, _TypPokojeID));
}
//-----------------------------------------------------------------------

int TSeznamPokoju::NajdiNepouziteID(void) const
    // vyuv "PridejPokoj()", najde prvn nepouit ID v seznamu pokoj,
    // nemlo by vadit, e toto ID ml nkdy piazen jin pokoj, protoe
    // ve o nm u je v databzi smazno
{
    for(int NoveID =1; ; NoveID++)
    {
        if(!SeznamObsahujeID(NoveID))
        {
            return NoveID;
        }
    }
}
//-------------------------------------------------------------------------

bool TSeznamPokoju::SeznamObsahujeID(int _ID) const
    // funkci vyuv metoda NajdiNepouziteID()
{
    vector< TPokoj >::const_iterator it;
    for(it = Pokoje.begin(); it != Pokoje.end(); it++)
    {
        if(it->GetPokojID() == _ID)
            return true;
    }

    return false; //v celem seznamu to nenaslo _ID
}
//--------------------------------------------------------------------------

void TSeznamPokoju::OdstranPokoj(const TMyString & _CisloPokoje)
    // Odebere pokoj z "Pokoje", pedpokld, e _CisloPokoje je ve vektoru
    // obsaeno
{
    vector< TPokoj >::iterator it;
    for(it = Pokoje.begin(); it != Pokoje.end(); it++)
    {
        if(it->GetCisloPokoje() == _CisloPokoje)
        {
            Pokoje.erase(it);
            break; // mel by tam byt jenom jeden, nema smysl pokracovat
        }
    }
}
//--------------------------------------------------------------------------

void TSeznamPokoju::UlozDoDatabaze(void) const
    // ulozi udaje z vektoru do databaze
    // chtelo by vylepsit, pokud by pri ukladani nastala chyba, jsou data
    // ztracena
{
    TMojeQuery * Dotaz = new TMojeQuery();

    Dotaz->SQL->Clear();
    Dotaz->SQL->Add("LOCK TABLES pokoje_tab WRITE, skupiny_pokoju_propojeni_tab WRITE");
    Dotaz->ExecSQL();

    UlozDoDatabazePokoje();

    Dotaz->SQL->Clear();
    Dotaz->SQL->Add("UNLOCK TABLES");
    Dotaz->ExecSQL();

    delete Dotaz;
}
//--------------------------------------------------------------------------

void TSeznamPokoju::UlozDoDatabazePokoje(void) const
    // vyuziva ji UlozDoDatabaze()
    // aktualizuje tabulku pokoje_tab
{
    TMojeQuery * Dotaz = new TMojeQuery();

    Dotaz->SQL->Clear();
    Dotaz->SQL->Add("DELETE FROM pokoje_tab");
    Dotaz->ExecSQL();

    vector< TPokoj >::const_iterator it;
    for(it = Pokoje.begin(); it != Pokoje.end(); it++)
    {
        Dotaz->SQL->Clear();
        Dotaz->SQL->Add(VytvorDotazInsertProUlozeni(it));
        Dotaz->ExecSQL();
    }

    delete Dotaz;
}
//--------------------------------------------------------------------------

TMyString TSeznamPokoju::VytvorDotazInsertProUlozeni(
                        const vector< TPokoj >::const_iterator _it) const
    // Vyuv ji "UlozDoDatabaze()"
{
    return
        TMyString("INSERT INTO pokoje_tab SET ")                   
        + "pokoj_id = \""
        + TMyString(_it->GetPokojID())
        + "\", cislo_pokoje = \""
        + _it->GetCisloPokoje()
        + "\", typ_pokoje_id = \""
        + TMyString(_it->GetTypPokojeID())
        + "\"";
}
//------------------------------------------------------------------------

TPokoj TSeznamPokoju::GetPokoj(const TMyString & _CisloPokoje) const
    // podle nazvu typu pokoje dohleda ID, predpoklada, ze nazev je spravny
{
    vector< TPokoj >::const_iterator it;
    for(it = Pokoje.begin(); it != Pokoje.end(); it++)
    {
        if(it->GetCisloPokoje() == _CisloPokoje)
            return *it;
    }

    return TPokoj(-1, "", -1); // sem by to nemlo dojt
}
//--------------------------------------------------------------------

int TSeznamPokoju::GetPokojID(const TMyString & _CisloPokoje) const
    // podle nazvu typu pokoje dohleda ID, predpoklada, ze nazev je spravny
{
    vector< TPokoj >::const_iterator it;
    for(it = Pokoje.begin(); it != Pokoje.end(); it++)
    {
        if(it->GetCisloPokoje() == _CisloPokoje)
            return it->GetPokojID();
    }

    return -1; // sem by to nemlo dojt
}
//--------------------------------------------------------------------

