#include "TSeznamTypuKlientu.h"
#include "TMojeQuery.h"

//-------------------------------------------------------------------------

TSeznamTypuKlientu::TSeznamTypuKlientu()
    // nacita data z tabuky "typy_klientu_tab", pri vytvareni TTypKlienta
    // se nacitaji jeste z tabulky "klient_zobrazit_tab"
{
    TMojeQuery * DotazTypyKlientu = new TMojeQuery();

    DotazTypyKlientu->SQL->Add("SELECT * FROM typy_klientu_tab");
    DotazTypyKlientu->Open();

    TypyKlientu.clear();
    if(!DotazTypyKlientu->IsEmpty())
    {
        DotazTypyKlientu->First();
        do
        {
            TypyKlientu.push_back(TTypKlienta(
                DotazTypyKlientu->FieldByName("typ_klienta_id")->AsInteger,
                DotazTypyKlientu->FieldByName("typ_klienta")->AsString      ));
            DotazTypyKlientu->Next();
        }
        while(!DotazTypyKlientu->Eof);
    }

    delete DotazTypyKlientu;

    Pozice = TypyKlientu.begin();
}
//-------------------------------------------------------------------------

void TSeznamTypuKlientu::GetSeznamTStringList(TStrings * _sl) const
    // do seznamu TStrings predaneho pres pointer vyplni nazvy typu klientu,
    // co tam bylo predtim smaze
{
    vector< TTypKlienta >::const_iterator it;

    _sl->Clear();

    for(it = TypyKlientu.begin(); it != TypyKlientu.end(); it++)
    {
        _sl->Add(it->GetNazevTypuKlienta());
    }
}
//-------------------------------------------------------------------------

int TSeznamTypuKlientu::GetTypKlientaID(const TMyString & _TypKlienta) const
    // podle nazvu typu klienta dohleda ID prislusneho typu
{
    vector< TTypKlienta >::const_iterator it;

    for(it = TypyKlientu.begin(); it != TypyKlientu.end(); it++)
    {
        if(it->GetNazevTypuKlienta() == _TypKlienta)
            return it->GetTypKlientaID();
    }

    return -1; //sem by to nemelo dojit
}
//---------------------------------------------------------------------------

bool TSeznamTypuKlientu::First(void)
    // pokud je neco v seznamu, nastavi interni ukazatel na prvni prvek a
    // vrati true
{
    Pozice = TypyKlientu.begin();
    if(Pozice != TypyKlientu.end())
    {
        return true;
    }
    else
    {
        return false;
    }
}
//----------------------------------------------

bool TSeznamTypuKlientu::Next(void)
    // pokud interni ukazatel neni na poslednim prvku, posune ho a vrati true
{
    if(Pozice && ((Pozice + 1) != TypyKlientu.end()))
    {
        Pozice++;
        return true;
    }
    else
    {
        return false;
    }
}
//-----------------------------------------------------

int TSeznamTypuKlientu::PoziceGetTypKlientaID(void) const
    // vrati ID typu klienta, na ktery ukazuje interni ukazatel
{
    return Pozice->GetTypKlientaID();
}
//----------------------------------------------------------

