// Tda reprezentujc jeden zznam v tabulce skupiny_pokoju_tab,
// prostednictvm tabulky skupiny_pokoju_propojeni_tab si nat pslun pokoje
// z tabulky pokoje_tab
//----------------------------------------------------------------------------
#ifndef _TSkupinaPokoju_h_
#define _TSkupinaPokoju_h_

#include "TMyString.h"
#include "TPokoj.h"
#include "TSeznamVytvorenychKomponent.h"
#include <vector>

using std::vector;
using MyStd::TMyString;
//----------------------------------------------------------------------------

class TSkupinaPokoju
{
public:
    TSkupinaPokoju(int _SkupinaPokojuID, const TMyString & _NazevSkupinyPokoju);
    ~TSkupinaPokoju(void) {};
    int GetSkupinaPokojuID(void) const { return SkupinaPokojuID; };
    const TMyString & GetNazevSkupinyPokoju(void) const { return NazevSkupinyPokoju; };
    void GetSeznamTStringList(TStrings * _sl) const;
    void OdstranPokojeZeSkupiny(const vector< TPokoj > & _PokojeKOdstraneni);
    void PridejPokojeDoSkupiny(const vector< TPokoj > & _PokojeNaPridani);
    void ZapisDoTabulkySkupinyPokojuPropojeni(void) const;
    void ZobrazObsazenostPokoju(const TControl * _Parent, int _lhrX, int _lhrY,
                    const TDate & _Od, const TDate & _Do,
                    TSeznamVytvorenychKomponent * _SeznamVytvorenychKomponent) const;

private:
    void NaplnVektorZDatabaze(int _SkupinaPokojuID);
    TMyString VytvorDotazInsertProZapisDoTabulkySkupinyPokojuPropojeni(
                            const vector< TPokoj >::const_iterator _it) const;
    int ZobrazDataNadCtverecky(const TControl * _Parent, int _lhrX, int _lhrY,
            int _MezeryX, const TDate & _Od, const TDate & _Do,
            TSeznamVytvorenychKomponent * _SeznamVytvorenychKomponent) const;
    int ZobrazDatumNadCtvereckem(const TControl * _Parent, int _lhrX, int _lhrY,
            const TDate & _Datum,
            TSeznamVytvorenychKomponent * _SeznamVytvorenychKomponent) const;

    int SkupinaPokojuID;
    TMyString NazevSkupinyPokoju;
    vector< TPokoj > SeznamPokojuVeSkupine;
    static const int ObsazenostSirkaNazvuPokoju = 70;
    static const int ObsazenostPosunutiY = 20; // vzdlenost dek v tabulce obsazenosti
    static const int ObsazenostPosunutiX = 20; // vzdlenost prvk na dku
};
//----------------------------------------------------------------------------

#endif
