#include "TTypKlienta.h"

#include "TMojeQuery.h"
#include <algorithm>

//--------------------------------------------------------------------------

TTypKlienta::TTypKlienta(int _TypKlientaID, const TMyString & _NazevTypuKlienta)
{
    TypKlientaID = _TypKlientaID;
    NazevTypuKlienta = _NazevTypuKlienta;
    NaplnVectorZobrazit(_TypKlientaID);
}
//--------------------------------------------------------------------------

int TTypKlienta::GetTypKlientaID(void) const
{
    return TypKlientaID;
}
//---------------------------------------------------------------------------

const TMyString & TTypKlienta::GetNazevTypuKlienta(void) const
{
    return NazevTypuKlienta;
}
//---------------------------------------------------------------------------

void TTypKlienta::NaplnVectorZobrazit(int _TypKlientaID)
    // z tabulky "klient_zobrazit_tab" naplni vector polozek k zobrazeni a
    // setridi je v takovem poradi, jak se maji zobrazovat (vzestupne podle
    // cisel v tabulce
{
    TMojeQuery * DotazTypKlientaZobrazit = new TMojeQuery(0);

    DotazTypKlientaZobrazit->SQL->Add(TMyString(
            "SELECT * FROM klient_zobrazit_tab WHERE typ_klienta_id = "
            + TMyString(_TypKlientaID)));
    DotazTypKlientaZobrazit->Open();

    if(!DotazTypKlientaZobrazit->IsEmpty())
    {
        DotazTypKlientaZobrazit->First();

        TStringList * Pole = new TStringList();
        DotazTypKlientaZobrazit->GetFieldNames(Pole);
        int PoradoveCislo;
        for(int i = 0; i < Pole->Count; i++)
        {
            if(Pole->Strings[i] == "typ_klienta_id")
                continue;
            PoradoveCislo = DotazTypKlientaZobrazit->FieldByName(
                                                Pole->Strings[i])->AsInteger;
            if(PoradoveCislo == 0)
                continue;
            Zobrazit.push_back(vector< pair<int, TMyString> >::value_type(
                PoradoveCislo,
                TMyString(Pole->Strings[i].c_str())
                            ));
        }
        sort(Zobrazit.begin(), Zobrazit.end());

        delete Pole;
    }

    PoziceZobrazit = 0;

    delete DotazTypKlientaZobrazit;

}
//---------------------------------------------------

bool TTypKlienta::FirstZobrazit()
    // posune intern ukazatel na prvn polozku v seznamu "Zobrazit" a vrati,
    // jestli je seznam prazdny nebo ne
{
    if(Zobrazit.begin() != Zobrazit.end())
    {
        PoziceZobrazit = Zobrazit.begin();
        return true;
    }
    else
    {
        return false;
    }
}
//----------------------------------------------

bool TTypKlienta::NextZobrazit()
    // pokud neni interni ukazatel na konci, posune ho a vrati true
    // jinak false
{
    if(PoziceZobrazit && ((PoziceZobrazit + 1) != Zobrazit.end()))
    {
        PoziceZobrazit++;
        return true;
    }
    else
    {
        return false;
    }
}
//-----------------------------------------------------

const TMyString & TTypKlienta::GetNazevPoleZobrazit() const
    // z polozky na kterou ukazuje interni ukazatel vrati popis pole k zobrazeni
{
    return PoziceZobrazit->second;
}
//----------------------------------------------------------

